#version 300 es

uniform mat4 u_Model;
uniform mat4 u_TransposeInvModel;
uniform mat4 u_MVP;
uniform mat4 u_Projection;
uniform mat4 u_View;

out vec2 v_uv0;
layout(location = 3) in vec2 attTexcoord0;
out vec2 v_uv1;
layout(location = 4) in vec2 attTexcoord1;
out vec3 v_posWS;
layout(location = 0) in vec3 attPosition;
out vec3 v_nDirWS;
layout(location = 1) in vec3 attNormal;
out vec3 v_tDirWS;
layout(location = 2) in vec3 attTangent;
out vec3 v_bDirWS;
out vec4 v_color;
layout(location = 5) in vec4 attColor;

void main()
{
    v_uv0 = attTexcoord0;
    v_uv1 = attTexcoord1;
    v_posWS = (u_Model * vec4(attPosition, 1.0)).xyz;
    v_nDirWS = vec4(normalize((u_TransposeInvModel * vec4(attNormal, 0.0)).xyz), 0.0).xyz;
    v_tDirWS = (u_Model * vec4(attTangent, 0.0)).xyz;
    v_bDirWS = cross(v_nDirWS, v_tDirWS);
    v_color = attColor;
    v_bDirWS = cross(v_nDirWS, v_tDirWS);
    gl_Position = ((u_Projection * u_View) * vec4(v_posWS, 1.0)) + (u_MVP * vec4(0.0));
}

