#pragma clang diagnostic ignored "-Wmissing-prototypes"
#pragma clang diagnostic ignored "-Wmissing-braces"

#include <metal_stdlib>
#include <simd/simd.h>

using namespace metal;

template<typename T, size_t Num>
struct spvUnsafeArray
{
    T elements[Num ? Num : 1];
    
    thread T& operator [] (size_t pos) thread
    {
        return elements[pos];
    }
    constexpr const thread T& operator [] (size_t pos) const thread
    {
        return elements[pos];
    }
    
    device T& operator [] (size_t pos) device
    {
        return elements[pos];
    }
    constexpr const device T& operator [] (size_t pos) const device
    {
        return elements[pos];
    }
    
    constexpr const constant T& operator [] (size_t pos) const constant
    {
        return elements[pos];
    }
    
    threadgroup T& operator [] (size_t pos) threadgroup
    {
        return elements[pos];
    }
    constexpr const threadgroup T& operator [] (size_t pos) const threadgroup
    {
        return elements[pos];
    }
};

// Implementation of the GLSL mod() function, which is slightly different than Metal fmod()
template<typename Tx, typename Ty>
inline Tx mod(Tx x, Ty y)
{
    return x - y * floor(x / y);
}

struct buffer_t
{
    float4 u_WorldSpaceCameraPos;
    spvUnsafeArray<float, 3> u_DirLightsEnabled;
    spvUnsafeArray<float4, 3> u_DirLightsDirection;
    spvUnsafeArray<float4, 3> u_DirLightsColor;
    spvUnsafeArray<float, 3> u_DirLightsIntensity;
    spvUnsafeArray<float, 2> u_PointLightsEnabled;
    spvUnsafeArray<float4, 2> u_PointLightsPosition;
    spvUnsafeArray<float4, 2> u_PointLightsColor;
    spvUnsafeArray<float, 2> u_PointLightsIntensity;
    spvUnsafeArray<float, 2> u_PointLightsAttenRangeInv;
    spvUnsafeArray<float, 2> u_SpotLightsEnabled;
    spvUnsafeArray<float4, 2> u_SpotLightsPosition;
    spvUnsafeArray<float4, 2> u_SpotLightsColor;
    spvUnsafeArray<float, 2> u_SpotLightsIntensity;
    spvUnsafeArray<float, 2> u_SpotLightsAttenRangeInv;
    spvUnsafeArray<float4, 2> u_SpotLightsDirection;
    spvUnsafeArray<float, 2> u_SpotLightsOuterAngleCos;
    spvUnsafeArray<float, 2> u_SpotLightsInnerAngleCos;
    spvUnsafeArray<float, 2> u_AreaLightsEnabled;
    spvUnsafeArray<float4, 2> u_AreaLightsColor;
    spvUnsafeArray<float, 2> u_AreaLightsIntensity;
    spvUnsafeArray<float4, 2> u_AreaLightsPoint0;
    spvUnsafeArray<float4, 2> u_AreaLightsPoint1;
    spvUnsafeArray<float4, 2> u_AreaLightsPoint2;
    spvUnsafeArray<float4, 2> u_AreaLightsPoint3;
    spvUnsafeArray<float, 2> u_AreaLightsShape;
    spvUnsafeArray<float, 2> u_AreaLightsTwoSide;
    float _Custom_Float_1;
    float _Custom_Float;
    float4 _Custom_Color;
    float _Custom_Float_2;
    float _Custom_Float_3;
};

constant float _14536 = {};
constant float3 _14537 = {};
constant float _17506 = {};
constant float4 _17507 = {};

struct main0_out
{
    float4 o_FragColor [[color(0)]];
};

struct main0_in
{
    float3 v_posWS [[user(locn0)]];
    float3 v_nDirWS [[user(locn1)]];
    float3 v_tDirWS [[user(locn2)]];
    float3 v_bDirWS [[user(locn3)]];
};

fragment main0_out main0(main0_in in [[stage_in]], constant buffer_t& buffer, texture2d<float> u_ltc_mat [[texture(0)]], texture2d<float> u_ltc_mag [[texture(1)]], texture2d<float> _EnvTex [[texture(2)]], sampler u_ltc_matSmplr [[sampler(0)]], sampler u_ltc_magSmplr [[sampler(1)]], sampler _EnvTexSmplr [[sampler(2)]])
{
    main0_out out = {};
    float2 _4401 = float2(in.v_posWS.xy);
    float2 _4404 = float2(buffer._Custom_Float_1);
    float2 _4462 = floor(fma(_4401, _4404, float2(dot(_4401 * _4404, float2(0.3660254180431365966796875)))));
    float2 _4469 = fma(_4401, _4404, -_4462) + float2(dot(_4462, float2(0.211324870586395263671875)));
    float _4471 = _4469.x;
    float _4473 = _4469.y;
    float2 _4476 = select(float2(0.0, 1.0), float2(1.0, 0.0), bool2(_4471 > _4473));
    float2 _4480 = (_4469 + float2(0.211324870586395263671875)) - _4476;
    float2 _4482 = _4469 + float2(-0.57735025882720947265625);
    float2 _4485 = mod(_4462, float2(289.0));
    float3 _4492 = float3(_4485.y) + float3(0.0, _4476.y, 1.0);
    float3 _4501 = (mod(((_4492 * 34.0) + float3(1.0)) * _4492, float3(289.0)) + float3(_4485.x)) + float3(0.0, _4476.x, 1.0);
    float3 _4516 = fast::max(float3(0.5) - float3(dot(_4469, _4469), dot(_4480, _4480), dot(_4482, _4482)), float3(0.0));
    float3 _4519 = _4516 * _4516;
    float3 _4526 = fract(mod(((_4501 * 34.0) + float3(1.0)) * _4501, float3(289.0)) * float3(0.024390242993831634521484375)) * 2.0;
    float3 _4528 = _4526 - float3(1.0);
    float3 _4532 = abs(_4528) - float3(0.5);
    float3 _4539 = _4528 - floor(_4526 + float3(-0.5));
    float2 _4411 = float2(in.v_posWS.xz);
    float2 _4639 = floor(fma(_4411, _4404, float2(dot(_4411 * _4404, float2(0.3660254180431365966796875)))));
    float2 _4646 = fma(_4411, _4404, -_4639) + float2(dot(_4639, float2(0.211324870586395263671875)));
    float _4648 = _4646.x;
    float _4650 = _4646.y;
    float2 _4653 = select(float2(0.0, 1.0), float2(1.0, 0.0), bool2(_4648 > _4650));
    float2 _4657 = (_4646 + float2(0.211324870586395263671875)) - _4653;
    float2 _4659 = _4646 + float2(-0.57735025882720947265625);
    float2 _4662 = mod(_4639, float2(289.0));
    float3 _4669 = float3(_4662.y) + float3(0.0, _4653.y, 1.0);
    float3 _4678 = (mod(((_4669 * 34.0) + float3(1.0)) * _4669, float3(289.0)) + float3(_4662.x)) + float3(0.0, _4653.x, 1.0);
    float3 _4693 = fast::max(float3(0.5) - float3(dot(_4646, _4646), dot(_4657, _4657), dot(_4659, _4659)), float3(0.0));
    float3 _4696 = _4693 * _4693;
    float3 _4703 = fract(mod(((_4678 * 34.0) + float3(1.0)) * _4678, float3(289.0)) * float3(0.024390242993831634521484375)) * 2.0;
    float3 _4705 = _4703 - float3(1.0);
    float3 _4709 = abs(_4705) - float3(0.5);
    float3 _4716 = _4705 - floor(_4703 + float3(-0.5));
    float2 _4421 = float2(in.v_posWS.yz);
    float2 _4816 = floor(fma(_4421, _4404, float2(dot(_4421 * _4404, float2(0.3660254180431365966796875)))));
    float2 _4823 = fma(_4421, _4404, -_4816) + float2(dot(_4816, float2(0.211324870586395263671875)));
    float _4825 = _4823.x;
    float _4827 = _4823.y;
    float2 _4830 = select(float2(0.0, 1.0), float2(1.0, 0.0), bool2(_4825 > _4827));
    float2 _4834 = (_4823 + float2(0.211324870586395263671875)) - _4830;
    float2 _4836 = _4823 + float2(-0.57735025882720947265625);
    float2 _4839 = mod(_4816, float2(289.0));
    float3 _4846 = float3(_4839.y) + float3(0.0, _4830.y, 1.0);
    float3 _4855 = (mod(((_4846 * 34.0) + float3(1.0)) * _4846, float3(289.0)) + float3(_4839.x)) + float3(0.0, _4830.x, 1.0);
    float3 _4870 = fast::max(float3(0.5) - float3(dot(_4823, _4823), dot(_4834, _4834), dot(_4836, _4836)), float3(0.0));
    float3 _4873 = _4870 * _4870;
    float3 _4880 = fract(mod(((_4855 * 34.0) + float3(1.0)) * _4855, float3(289.0)) * float3(0.024390242993831634521484375)) * 2.0;
    float3 _4882 = _4880 - float3(1.0);
    float3 _4886 = abs(_4882) - float3(0.5);
    float3 _4893 = _4882 - floor(_4880 + float3(-0.5));
    float _4428 = (fma(dot((_4519 * _4519) * (float3(1.792842864990234375) - (fma(_4539, _4539, _4532 * _4532) * 0.8537347316741943359375)), float3(fma(_4539.x, _4471, _4532.x * _4473), fma(_4539.yz, float2(_4480.x, _4482.x), _4532.yz * float2(_4480.y, _4482.y)))), 65.0, 0.5) + fma(dot((_4696 * _4696) * (float3(1.792842864990234375) - (fma(_4716, _4716, _4709 * _4709) * 0.8537347316741943359375)), float3(fma(_4716.x, _4648, _4709.x * _4650), fma(_4716.yz, float2(_4657.x, _4659.x), _4709.yz * float2(_4657.y, _4659.y)))), 65.0, 0.5)) + fma(dot((_4873 * _4873) * (float3(1.792842864990234375) - (fma(_4893, _4893, _4886 * _4886) * 0.8537347316741943359375)), float3(fma(_4893.x, _4825, _4886.x * _4827), fma(_4893.yz, float2(_4834.x, _4836.x), _4886.yz * float2(_4834.y, _4836.y)))), 65.0, 0.5);
    float _3994 = fma(_4428, 0.3333333432674407958984375, buffer._Custom_Float - 1.0);
    float3 _4029 = fast::normalize(in.v_nDirWS);
    float3 _5076 = fast::normalize(buffer.u_WorldSpaceCameraPos.xyz - in.v_posWS);
    float3 _14538;
    if (dot(_5076, _4029) < (-0.0500000007450580596923828125))
    {
        _14538 = -_4029;
    }
    else
    {
        _14538 = _4029;
    }
    float3 _5120 = float3x3(fast::normalize(in.v_tDirWS), fast::normalize(in.v_bDirWS), _14538) * fast::normalize(float3(0.0, 0.0, 1.0));
    float _5154 = fast::max(0.0, dot(_5120, _5076));
    float3 _5162 = fast::normalize(reflect(-_5076, _5120));
    float _5253 = fast::min(1.0 + dot(_5162, _14538), 1.0);
    float _5259 = fast::clamp(pow(fast::max(_5154 + 1.0, 9.9999997473787516355514526367188e-06), 0.03125), 0.0, 1.0) * (_5253 * _5253);
    float3 _5566 = fast::normalize(_5120);
    float _5569 = -_5566.z;
    float _5571 = _5566.x;
    float _5573 = fma((_5571 < 0.0) ? (-1.0) : 1.0, acos(fast::clamp(_5569 / length(float2(_5571, _5569)), -1.0, 1.0)), -1.57079637050628662109375);
    float _5578 = acos(_5566.y);
    float _5593 = fract(fma(_5573, 0.15915493667125701904296875, floor(_5573 * 0.15915493667125701904296875)) + 1.0);
    float _5621 = floor(7.0);
    float2 _14544;
    float2 _14551;
    if (abs(_5621) < 0.001000000047497451305389404296875)
    {
        _14551 = float2(fma(_5593, 0.99609375, 0.001953125) * 0.5, fma(fma(_5578, 0.315823078155517578125, 0.00390625), 0.25, 0.5));
        _14544 = float2(fma(_5593, 0.998046875, 0.0009765625), fma(_5578, 0.3170664608478546142578125, 0.001953125) * 0.5);
    }
    else
    {
        float2 _14545;
        float2 _14552;
        if (abs(_5621 - 1.0) < 0.001000000047497451305389404296875)
        {
            float _5674 = fma(_5593, 0.99609375, 0.001953125);
            float _5684 = fma(fma(_5578, 0.315823078155517578125, 0.00390625), 0.25, 0.5);
            _14552 = float2(fma(_5674, 0.5, 0.5), _5684);
            _14545 = float2(_5674 * 0.5, _5684);
        }
        else
        {
            float2 _14546;
            float2 _14553;
            if (abs(_5621 - 2.0) < 0.001000000047497451305389404296875)
            {
                float _5712 = fma(_5593, 0.99609375, 0.001953125);
                float _5720 = fma(_5578, 0.315823078155517578125, 0.00390625);
                _14553 = float2(_5712 * 0.5, fma(_5720, 0.25, 0.75));
                _14546 = float2(fma(_5712, 0.5, 0.5), fma(_5720, 0.25, 0.5));
            }
            else
            {
                float2 _14547;
                float2 _14554;
                if (abs(_5621 - 3.0) < 0.001000000047497451305389404296875)
                {
                    _14554 = float2(fma(fma(_5593, 0.9921875, 0.00390625), 0.25, 0.5), fma(fma(_5578, 0.3133362829685211181640625, 0.0078125), 0.125, 0.75));
                    _14547 = float2(fma(_5593, 0.99609375, 0.001953125) * 0.5, fma(fma(_5578, 0.315823078155517578125, 0.00390625), 0.25, 0.75));
                }
                else
                {
                    float2 _14548;
                    float2 _14555;
                    if (abs(_5621 - 4.0) < 0.001000000047497451305389404296875)
                    {
                        float _5788 = fma(_5593, 0.9921875, 0.00390625);
                        float _5798 = fma(fma(_5578, 0.3133362829685211181640625, 0.0078125), 0.125, 0.75);
                        _14555 = float2(fma(_5788, 0.25, 0.75), _5798);
                        _14548 = float2(fma(_5788, 0.25, 0.5), _5798);
                    }
                    else
                    {
                        float2 _14549;
                        float2 _14556;
                        if (abs(_5621 - 5.0) < 0.001000000047497451305389404296875)
                        {
                            float _5826 = fma(_5593, 0.9921875, 0.00390625);
                            float _5834 = fma(_5578, 0.3133362829685211181640625, 0.0078125);
                            _14556 = float2(fma(_5826, 0.25, 0.5), fma(_5834, 0.125, 0.875));
                            _14549 = float2(fma(_5826, 0.25, 0.75), fma(_5834, 0.125, 0.75));
                        }
                        else
                        {
                            float2 _14550;
                            float2 _14557;
                            if (abs(_5621 - 6.0) < 0.001000000047497451305389404296875)
                            {
                                float _5864 = fma(_5593, 0.9921875, 0.00390625);
                                float _5874 = fma(fma(_5578, 0.3133362829685211181640625, 0.0078125), 0.125, 0.875);
                                _14557 = float2(fma(_5864, 0.25, 0.75), _5874);
                                _14550 = float2(fma(_5864, 0.25, 0.5), _5874);
                            }
                            else
                            {
                                float2 _17361 = float2(fma(fma(_5593, 0.9921875, 0.00390625), 0.25, 0.75), fma(fma(_5578, 0.3133362829685211181640625, 0.0078125), 0.125, 0.875));
                                _14557 = _17361;
                                _14550 = _17361;
                            }
                            _14556 = _14557;
                            _14549 = _14550;
                        }
                        _14555 = _14556;
                        _14548 = _14549;
                    }
                    _14554 = _14555;
                    _14547 = _14548;
                }
                _14553 = _14554;
                _14546 = _14547;
            }
            _14552 = _14553;
            _14545 = _14546;
        }
        _14551 = _14552;
        _14544 = _14545;
    }
    float4 _5934 = _EnvTex.sample(_EnvTexSmplr, _14544);
    float4 _5937 = _EnvTex.sample(_EnvTexSmplr, _14551);
    float4 _5940 = mix(_5934, _5937, float4(7.0 - _5621));
    float3 _5506 = (float3(0.050000011920928955078125) * ((_5940.xyz / float3(_5940.w)) * 1.0)) * 1.0;
    float3 _6045 = fast::normalize(mix(_5162, _5120, float3(0.125)));
    float _6048 = -_6045.z;
    float _6050 = _6045.x;
    float _6052 = fma((_6050 < 0.0) ? (-1.0) : 1.0, acos(fast::clamp(_6048 / length(float2(_6050, _6048)), -1.0, 1.0)), -1.57079637050628662109375);
    float _6057 = acos(_6045.y);
    float _6072 = fract(fma(_6052, 0.15915493667125701904296875, floor(_6052 * 0.15915493667125701904296875)) + 1.0);
    float _6100 = floor(3.5);
    float2 _14573;
    float2 _14580;
    if (abs(_6100) < 0.001000000047497451305389404296875)
    {
        _14580 = float2(fma(_6072, 0.99609375, 0.001953125) * 0.5, fma(fma(_6057, 0.315823078155517578125, 0.00390625), 0.25, 0.5));
        _14573 = float2(fma(_6072, 0.998046875, 0.0009765625), fma(_6057, 0.3170664608478546142578125, 0.001953125) * 0.5);
    }
    else
    {
        float2 _14574;
        float2 _14581;
        if (abs(_6100 - 1.0) < 0.001000000047497451305389404296875)
        {
            float _6153 = fma(_6072, 0.99609375, 0.001953125);
            float _6163 = fma(fma(_6057, 0.315823078155517578125, 0.00390625), 0.25, 0.5);
            _14581 = float2(fma(_6153, 0.5, 0.5), _6163);
            _14574 = float2(_6153 * 0.5, _6163);
        }
        else
        {
            float2 _14575;
            float2 _14582;
            if (abs(_6100 - 2.0) < 0.001000000047497451305389404296875)
            {
                float _6191 = fma(_6072, 0.99609375, 0.001953125);
                float _6199 = fma(_6057, 0.315823078155517578125, 0.00390625);
                _14582 = float2(_6191 * 0.5, fma(_6199, 0.25, 0.75));
                _14575 = float2(fma(_6191, 0.5, 0.5), fma(_6199, 0.25, 0.5));
            }
            else
            {
                float2 _14576;
                float2 _14583;
                if (abs(_6100 - 3.0) < 0.001000000047497451305389404296875)
                {
                    _14583 = float2(fma(fma(_6072, 0.9921875, 0.00390625), 0.25, 0.5), fma(fma(_6057, 0.3133362829685211181640625, 0.0078125), 0.125, 0.75));
                    _14576 = float2(fma(_6072, 0.99609375, 0.001953125) * 0.5, fma(fma(_6057, 0.315823078155517578125, 0.00390625), 0.25, 0.75));
                }
                else
                {
                    float2 _14577;
                    float2 _14584;
                    if (abs(_6100 - 4.0) < 0.001000000047497451305389404296875)
                    {
                        float _6267 = fma(_6072, 0.9921875, 0.00390625);
                        float _6277 = fma(fma(_6057, 0.3133362829685211181640625, 0.0078125), 0.125, 0.75);
                        _14584 = float2(fma(_6267, 0.25, 0.75), _6277);
                        _14577 = float2(fma(_6267, 0.25, 0.5), _6277);
                    }
                    else
                    {
                        float2 _14578;
                        float2 _14585;
                        if (abs(_6100 - 5.0) < 0.001000000047497451305389404296875)
                        {
                            float _6305 = fma(_6072, 0.9921875, 0.00390625);
                            float _6313 = fma(_6057, 0.3133362829685211181640625, 0.0078125);
                            _14585 = float2(fma(_6305, 0.25, 0.5), fma(_6313, 0.125, 0.875));
                            _14578 = float2(fma(_6305, 0.25, 0.75), fma(_6313, 0.125, 0.75));
                        }
                        else
                        {
                            float2 _14579;
                            float2 _14586;
                            if (abs(_6100 - 6.0) < 0.001000000047497451305389404296875)
                            {
                                float _6343 = fma(_6072, 0.9921875, 0.00390625);
                                float _6353 = fma(fma(_6057, 0.3133362829685211181640625, 0.0078125), 0.125, 0.875);
                                _14586 = float2(fma(_6343, 0.25, 0.75), _6353);
                                _14579 = float2(fma(_6343, 0.25, 0.5), _6353);
                            }
                            else
                            {
                                float2 _17402 = float2(fma(fma(_6072, 0.9921875, 0.00390625), 0.25, 0.75), fma(fma(_6057, 0.3133362829685211181640625, 0.0078125), 0.125, 0.875));
                                _14586 = _17402;
                                _14579 = _17402;
                            }
                            _14585 = _14586;
                            _14578 = _14579;
                        }
                        _14584 = _14585;
                        _14577 = _14578;
                    }
                    _14583 = _14584;
                    _14576 = _14577;
                }
                _14582 = _14583;
                _14575 = _14576;
            }
            _14581 = _14582;
            _14574 = _14575;
        }
        _14580 = _14581;
        _14573 = _14574;
    }
    float4 _6413 = _EnvTex.sample(_EnvTexSmplr, _14573);
    float4 _6416 = _EnvTex.sample(_EnvTexSmplr, _14580);
    float4 _6419 = mix(_6413, _6416, float4(3.5 - _6100));
    float2 _6466 = (float2(-1.03999996185302734375, 1.03999996185302734375) * fma(fast::min(0.25, exp2((-9.27999973297119140625) * _5154)), 0.5, 0.02875000052154064178466796875)) + float2(0.7539999485015869140625, -0.02899999916553497314453125);
    float3 _5514 = ((((float3(0.951999962329864501953125) * _6466.x) + float3(_6466.y)) * fast::max(float3(_5259), ((((float3(1.61006081104278564453125) * _5259) + float3(-3.9232351779937744140625)) * _5259) + float3(3.3132503032684326171875)) * _5259)) * ((_6419.xyz / float3(_6419.w)) * 1.0)) * 1.0;
    float3 _6530 = fast::normalize(-buffer.u_DirLightsDirection[0].xyz);
    float _6544 = (buffer.u_DirLightsIntensity[0] * buffer.u_DirLightsEnabled[0]) * 3.1415920257568359375;
    float3 _6558 = fast::normalize(_6530 + _5076);
    float _6572 = fast::max(0.0, dot(_5120, _6530));
    float _6579 = fast::max(0.0, dot(_5120, _6558));
    float3 _14773;
    float3 _14774;
    if (buffer.u_DirLightsEnabled[0] > 0.5)
    {
        float _6723 = 1.0 - fast::max(0.0, fast::max(0.0, dot(_5076, _6558)));
        float _6737 = _6723 * _6723;
        float _6750 = 1.0 - _6572;
        float _6778 = fma(fma(_6579, 0.0625, -_6579), _6579, 1.0);
        _14774 = _5514 + ((((((float3(0.951999962329864501953125) + (float3(0.048000037670135498046875) * ((_6737 * _6737) * _6723))) * ((0.019894368946552276611328125 / fma(_6778, _6778, 1.0000000116860974230803549289703e-07)) * (0.5 / (fma(0.25, fma(_5154, _6750, _6572), _5154 * fma(0.25, _6750, _6572)) + 9.9999997473787516355514526367188e-06)))) * _6572) * buffer.u_DirLightsColor[0].xyz) * _6544) * 1.0);
        _14773 = _5506 + ((((float3(0.050000011920928955078125) * buffer.u_DirLightsColor[0].xyz) * _6544) * (_6572 * 0.31830990314483642578125)) * 1.0);
    }
    else
    {
        _14774 = _5514;
        _14773 = _5506;
    }
    float3 _6798 = fast::normalize(-buffer.u_DirLightsDirection[1].xyz);
    float _6812 = (buffer.u_DirLightsIntensity[1] * buffer.u_DirLightsEnabled[1]) * 3.1415920257568359375;
    float3 _6826 = fast::normalize(_6798 + _5076);
    float _6840 = fast::max(0.0, dot(_5120, _6798));
    float _6847 = fast::max(0.0, dot(_5120, _6826));
    float3 _14951;
    float3 _14952;
    if (buffer.u_DirLightsEnabled[1] > 0.5)
    {
        float _6983 = 1.0 - fast::max(0.0, fast::max(0.0, dot(_5076, _6826)));
        float _6997 = _6983 * _6983;
        float _7015 = fma(fma(_6847, 0.0625, -_6847), _6847, 1.0);
        _14952 = _14774 + ((((((float3(0.951999962329864501953125) + (float3(0.048000037670135498046875) * ((_6997 * _6997) * _6983))) * (0.00497359223663806915283203125 / fma(_7015, _7015, 1.0000000116860974230803549289703e-07))) * _6840) * buffer.u_DirLightsColor[1].xyz) * _6812) * 1.0);
        _14951 = _14773 + ((((float3(0.050000011920928955078125) * buffer.u_DirLightsColor[1].xyz) * _6812) * (_6840 * 0.31830990314483642578125)) * 1.0);
    }
    else
    {
        _14952 = _14774;
        _14951 = _14773;
    }
    float3 _7035 = fast::normalize(-buffer.u_DirLightsDirection[2].xyz);
    float _7049 = (buffer.u_DirLightsIntensity[2] * buffer.u_DirLightsEnabled[2]) * 3.1415920257568359375;
    float3 _7063 = fast::normalize(_7035 + _5076);
    float _7077 = fast::max(0.0, dot(_5120, _7035));
    float _7084 = fast::max(0.0, dot(_5120, _7063));
    float3 _15140;
    float3 _15141;
    if (buffer.u_DirLightsEnabled[2] > 0.5)
    {
        float _7220 = 1.0 - fast::max(0.0, fast::max(0.0, dot(_5076, _7063)));
        float _7234 = _7220 * _7220;
        float _7252 = fma(fma(_7084, 0.0625, -_7084), _7084, 1.0);
        _15141 = _14952 + ((((((float3(0.951999962329864501953125) + (float3(0.048000037670135498046875) * ((_7234 * _7234) * _7220))) * (0.00497359223663806915283203125 / fma(_7252, _7252, 1.0000000116860974230803549289703e-07))) * _7077) * buffer.u_DirLightsColor[2].xyz) * _7049) * 1.0);
        _15140 = _14951 + ((((float3(0.050000011920928955078125) * buffer.u_DirLightsColor[2].xyz) * _7049) * (_7077 * 0.31830990314483642578125)) * 1.0);
    }
    else
    {
        _15141 = _14952;
        _15140 = _14951;
    }
    float3 _7281 = buffer.u_PointLightsPosition[0].xyz - in.v_posWS;
    float _7283 = length(_7281);
    float3 _7287 = _7281 / float3(_7283);
    float _7301 = (buffer.u_PointLightsIntensity[0] * buffer.u_PointLightsEnabled[0]) * 3.1415920257568359375;
    float _7308 = _7283 * buffer.u_PointLightsAttenRangeInv[0];
    float _7334 = _7308 * _7308;
    float _7341 = fast::clamp(fma(-_7334, _7334, 1.0), 0.0, 1.0);
    float3 _7322 = float3(((_7341 * _7341) * fma(_7308, _7308, 1.0)) * 0.25);
    float3 _7358 = fast::normalize(_7287 + _5076);
    float _7372 = fast::max(0.0, dot(_5120, _7287));
    float _7379 = fast::max(0.0, dot(_5120, _7358));
    float3 _15340;
    float3 _15341;
    if (buffer.u_PointLightsEnabled[0] > 0.5)
    {
        float _7523 = 1.0 - fast::max(0.0, fast::max(0.0, dot(_5076, _7358)));
        float _7537 = _7523 * _7523;
        float _7550 = 1.0 - _7372;
        float _7578 = fma(fma(_7379, 0.0625, -_7379), _7379, 1.0);
        _15341 = _15141 + (((((((float3(0.951999962329864501953125) + (float3(0.048000037670135498046875) * ((_7537 * _7537) * _7523))) * ((0.019894368946552276611328125 / fma(_7578, _7578, 1.0000000116860974230803549289703e-07)) * (0.5 / (fma(0.25, fma(_5154, _7550, _7372), _5154 * fma(0.25, _7550, _7372)) + 9.9999997473787516355514526367188e-06)))) * _7372) * buffer.u_PointLightsColor[0].xyz) * _7301) * _7322) * 1.0);
        _15340 = _15140 + (((((float3(0.050000011920928955078125) * buffer.u_PointLightsColor[0].xyz) * _7301) * _7322) * (_7372 * 0.31830990314483642578125)) * 1.0);
    }
    else
    {
        _15341 = _15141;
        _15340 = _15140;
    }
    float3 _7607 = buffer.u_PointLightsPosition[1].xyz - in.v_posWS;
    float _7609 = length(_7607);
    float3 _7613 = _7607 / float3(_7609);
    float _7627 = (buffer.u_PointLightsIntensity[1] * buffer.u_PointLightsEnabled[1]) * 3.1415920257568359375;
    float _7634 = _7609 * buffer.u_PointLightsAttenRangeInv[1];
    float _7660 = _7634 * _7634;
    float _7667 = fast::clamp(fma(-_7660, _7660, 1.0), 0.0, 1.0);
    float3 _7648 = float3(((_7667 * _7667) * fma(_7634, _7634, 1.0)) * 0.25);
    float3 _7684 = fast::normalize(_7613 + _5076);
    float _7698 = fast::max(0.0, dot(_5120, _7613));
    float _7705 = fast::max(0.0, dot(_5120, _7684));
    float3 _15551;
    float3 _15552;
    if (buffer.u_PointLightsEnabled[1] > 0.5)
    {
        float _7841 = 1.0 - fast::max(0.0, fast::max(0.0, dot(_5076, _7684)));
        float _7855 = _7841 * _7841;
        float _7873 = fma(fma(_7705, 0.0625, -_7705), _7705, 1.0);
        _15552 = _15341 + (((((((float3(0.951999962329864501953125) + (float3(0.048000037670135498046875) * ((_7855 * _7855) * _7841))) * (0.00497359223663806915283203125 / fma(_7873, _7873, 1.0000000116860974230803549289703e-07))) * _7698) * buffer.u_PointLightsColor[1].xyz) * _7627) * _7648) * 1.0);
        _15551 = _15340 + (((((float3(0.050000011920928955078125) * buffer.u_PointLightsColor[1].xyz) * _7627) * _7648) * (_7698 * 0.31830990314483642578125)) * 1.0);
    }
    else
    {
        _15552 = _15341;
        _15551 = _15340;
    }
    float3 _7904 = buffer.u_SpotLightsPosition[0].xyz - in.v_posWS;
    float _7906 = length(_7904);
    float3 _7910 = _7904 / float3(_7906);
    float _7924 = (buffer.u_SpotLightsIntensity[0] * buffer.u_SpotLightsEnabled[0]) * 3.1415920257568359375;
    float _7931 = _7906 * buffer.u_SpotLightsAttenRangeInv[0];
    float _7978 = _7931 * _7931;
    float _7985 = fast::clamp(fma(-_7978, _7978, 1.0), 0.0, 1.0);
    float3 _7966 = float3((((_7985 * _7985) * fma(_7931, _7931, 1.0)) * 0.25) * smoothstep(buffer.u_SpotLightsOuterAngleCos[0], buffer.u_SpotLightsInnerAngleCos[0], fast::max(0.0, dot(_7910, fast::normalize(-buffer.u_SpotLightsDirection[0].xyz)))));
    float3 _8002 = fast::normalize(_7910 + _5076);
    float _8016 = fast::max(0.0, dot(_5120, _7910));
    float _8023 = fast::max(0.0, dot(_5120, _8002));
    float3 _15773;
    float3 _15774;
    if (buffer.u_SpotLightsEnabled[0] > 0.5)
    {
        float _8167 = 1.0 - fast::max(0.0, fast::max(0.0, dot(_5076, _8002)));
        float _8181 = _8167 * _8167;
        float _8194 = 1.0 - _8016;
        float _8222 = fma(fma(_8023, 0.0625, -_8023), _8023, 1.0);
        _15774 = _15552 + (((((((float3(0.951999962329864501953125) + (float3(0.048000037670135498046875) * ((_8181 * _8181) * _8167))) * ((0.019894368946552276611328125 / fma(_8222, _8222, 1.0000000116860974230803549289703e-07)) * (0.5 / (fma(0.25, fma(_5154, _8194, _8016), _5154 * fma(0.25, _8194, _8016)) + 9.9999997473787516355514526367188e-06)))) * _8016) * buffer.u_SpotLightsColor[0].xyz) * _7924) * _7966) * 1.0);
        _15773 = _15551 + (((((float3(0.050000011920928955078125) * buffer.u_SpotLightsColor[0].xyz) * _7924) * _7966) * (_8016 * 0.31830990314483642578125)) * 1.0);
    }
    else
    {
        _15774 = _15552;
        _15773 = _15551;
    }
    float3 _8253 = buffer.u_SpotLightsPosition[1].xyz - in.v_posWS;
    float _8255 = length(_8253);
    float3 _8259 = _8253 / float3(_8255);
    float _8273 = (buffer.u_SpotLightsIntensity[1] * buffer.u_SpotLightsEnabled[1]) * 3.1415920257568359375;
    float _8280 = _8255 * buffer.u_SpotLightsAttenRangeInv[1];
    float _8327 = _8280 * _8280;
    float _8334 = fast::clamp(fma(-_8327, _8327, 1.0), 0.0, 1.0);
    float3 _8315 = float3((((_8334 * _8334) * fma(_8280, _8280, 1.0)) * 0.25) * smoothstep(buffer.u_SpotLightsOuterAngleCos[1], buffer.u_SpotLightsInnerAngleCos[1], fast::max(0.0, dot(_8259, fast::normalize(-buffer.u_SpotLightsDirection[1].xyz)))));
    float3 _8351 = fast::normalize(_8259 + _5076);
    float _8365 = fast::max(0.0, dot(_5120, _8259));
    float _8372 = fast::max(0.0, dot(_5120, _8351));
    float3 _16006;
    float3 _16007;
    if (buffer.u_SpotLightsEnabled[1] > 0.5)
    {
        float _8508 = 1.0 - fast::max(0.0, fast::max(0.0, dot(_5076, _8351)));
        float _8522 = _8508 * _8508;
        float _8540 = fma(fma(_8372, 0.0625, -_8372), _8372, 1.0);
        _16007 = _15774 + (((((((float3(0.951999962329864501953125) + (float3(0.048000037670135498046875) * ((_8522 * _8522) * _8508))) * (0.00497359223663806915283203125 / fma(_8540, _8540, 1.0000000116860974230803549289703e-07))) * _8365) * buffer.u_SpotLightsColor[1].xyz) * _8273) * _8315) * 1.0);
        _16006 = _15773 + (((((float3(0.050000011920928955078125) * buffer.u_SpotLightsColor[1].xyz) * _8273) * _8315) * (_8365 * 0.31830990314483642578125)) * 1.0);
    }
    else
    {
        _16007 = _15774;
        _16006 = _15773;
    }
    float _8570 = (buffer.u_AreaLightsIntensity[0] * buffer.u_AreaLightsEnabled[0]) * 3.1415920257568359375;
    float3 _16755;
    float3 _16796;
    if (buffer.u_AreaLightsEnabled[0] > 0.5)
    {
        float3 _8730;
        float3 _8734;
        bool _8737;
        float3 _16349;
        do
        {
            _8730 = fast::normalize(_5076 - (_5120 * _5154));
            _8734 = cross(_5120, _8730);
            _8737 = buffer.u_AreaLightsShape[0] > 0.5;
            if (_8737)
            {
                float3x3 _8756 = transpose(float3x3(_8730, _8734, _5120));
                float3 _8763 = _8756 * (buffer.u_AreaLightsPoint0[0].xyz - in.v_posWS);
                float3 _8771 = _8756 * (buffer.u_AreaLightsPoint1[0].xyz - in.v_posWS);
                float3 _8779 = _8756 * (buffer.u_AreaLightsPoint2[0].xyz - in.v_posWS);
                float3 _8801 = float3x3(float3(1.0, 0.0, 0.0), float3(0.0, 1.0, 0.0), float3(0.0, 0.0, 1.0)) * ((_8763 + _8779) * 0.5);
                float3 _8804 = float3x3(float3(1.0, 0.0, 0.0), float3(0.0, 1.0, 0.0), float3(0.0, 0.0, 1.0)) * ((_8771 - _8779) * 0.5);
                float3 _8807 = float3x3(float3(1.0, 0.0, 0.0), float3(0.0, 1.0, 0.0), float3(0.0, 0.0, 1.0)) * ((_8771 - _8763) * 0.5);
                if (buffer.u_AreaLightsTwoSide[0] < 0.5)
                {
                    if (dot(cross(_8804, _8807), _8801) < 0.0)
                    {
                        _16349 = float3(0.0);
                        break;
                    }
                }
                float _8823 = dot(_8804, _8804);
                float _8826 = dot(_8807, _8807);
                float _8829 = dot(_8804, _8807);
                float _8834 = _8823 * _8826;
                float3 _16304;
                float3 _16305;
                float _16310;
                float _16312;
                if ((abs(_8829) / sqrt(_8834)) > 9.9999997473787516355514526367188e-05)
                {
                    float _8841 = _8823 + _8826;
                    float _8851 = sqrt(fma(-_8829, _8829, _8834));
                    float _8856 = sqrt(fma(-2.0, _8851, _8841));
                    float _8862 = sqrt(fma(2.0, _8851, _8841));
                    float _8866 = fma(0.5, _8856, 0.5 * _8862);
                    float _8870 = fma(0.5, _8856, _8862 * (-0.5));
                    float3 _16302;
                    float3 _16303;
                    if (_8823 > _8826)
                    {
                        float3 _8878 = _8804 * _8829;
                        float _17468 = -_8823;
                        _16303 = _8878 + (_8807 * fma(_8870, _8870, _17468));
                        _16302 = _8878 + (_8807 * fma(_8866, _8866, _17468));
                    }
                    else
                    {
                        float3 _8897 = _8807 * _8829;
                        float _17466 = -_8826;
                        _16303 = _8897 + (_8804 * fma(_8870, _8870, _17466));
                        _16302 = _8897 + (_8804 * fma(_8866, _8866, _17466));
                    }
                    _16312 = 1.0 / (_8870 * _8870);
                    _16310 = 1.0 / (_8866 * _8866);
                    _16305 = fast::normalize(_16303);
                    _16304 = fast::normalize(_16302);
                }
                else
                {
                    float _8926 = 1.0 / _8823;
                    float _8930 = 1.0 / _8826;
                    _16312 = _8930;
                    _16310 = _8926;
                    _16305 = _8807 * sqrt(_8930);
                    _16304 = _8804 * sqrt(_8926);
                }
                float3 _8942 = cross(_16304, _16305);
                float3 _16306;
                if (dot(_8801, _8942) < 0.0)
                {
                    _16306 = _8942 * (-1.0);
                }
                else
                {
                    _16306 = _8942;
                }
                float _8953 = dot(_16306, _8801);
                float _8958 = dot(_16304, _8801) / _8953;
                float _8963 = dot(_16305, _8801) / _8953;
                float _8970 = _8953 * _8953;
                float _8972 = _16310 * _8970;
                float _8977 = _16312 * _8970;
                float _8980 = _8972 * _8977;
                float _8987 = fma(_8958, _8958, 1.0);
                float _17470 = -_8972;
                float4 _14306 = _17507;
                _14306.x = _8980;
                float4 _14308 = _14306;
                _14308.y = fma(-_16312, _8970, fma(_8980, fma(_8963, _8963, _8987), _17470));
                float4 _14310 = _14308;
                _14310.z = fma(-_8977, fma(_8963, _8963, 1.0), fma(_17470, _8987, 1.0));
                float2 _9294 = _14310.yz * float2(0.3333333432674407958984375);
                float _9296 = _9294.x;
                float4 _14312 = _14310;
                _14312.y = _9296;
                float _9298 = _9294.y;
                float _9309 = -_9298;
                float _9315 = fma(_9309, _9298, _9296);
                float _9318 = -_9296;
                float _9324 = fma(_9318, _9298, _8980);
                float _9333 = dot(float2(_9298, _9318), _14312.xy);
                float _9356 = sqrt(dot(float2(4.0 * _9315, -_9324), float3(_9315, _9324, _9333).zy));
                float _9359 = precise::atan2(_9356, -fma((-2.0) * _9298, _9315, _9324));
                float _9364 = 2.0 * sqrt(-_9315);
                float _9366 = cos(_9359 * 0.3333333432674407958984375);
                float _9375 = _9364 * cos(fma(_9359, 0.3333333432674407958984375, 2.094395160675048828125));
                float _9389 = ((fma(_9364, _9366, _9375) > (2.0 * _9298)) ? (_9364 * _9366) : _9375) - _9298;
                float _9396 = -_8980;
                float _9401 = 2.0 * _9296;
                float _9412 = precise::atan2(_8980 * _9356, -fma(_9396, _9324, _9401 * _9333));
                float _9417 = 2.0 * sqrt(-_9333);
                float _9419 = cos(_9412 * 0.3333333432674407958984375);
                float _9428 = _9417 * cos(fma(_9412, 0.3333333432674407958984375, 2.094395160675048828125));
                float _9444 = ((fma(_9417, _9419, _9428) < _9401) ? (_9417 * _9419) : _9428) + _9296;
                float _9462 = fma(-_9389, _9444, _8980);
                float _9488 = _9396 / _9444;
                float _9493 = fma(_9296, _9462, -(_9298 * (_9389 * _9396))) / fma(_9309, _9462, _9296 * _9444);
                float3 _9499 = float3(_9488, _9493, _9389);
                bool _9504 = _9488 < _9493;
                bool _9512;
                if (_9504)
                {
                    _9512 = _9488 < _9389;
                }
                else
                {
                    _9512 = _9504;
                }
                float3 _16317;
                if (_9512)
                {
                    _16317 = _9499.yxz;
                }
                else
                {
                    bool _9521 = _9389 < _9488;
                    bool _9529;
                    if (_9521)
                    {
                        _9529 = _9389 < _9493;
                    }
                    else
                    {
                        _9529 = _9521;
                    }
                    float3 _16318;
                    if (_9529)
                    {
                        _16318 = _9499.xzy;
                    }
                    else
                    {
                        _16318 = _9499;
                    }
                    _16317 = _16318;
                }
                float _17477 = -_16317.y;
                float _9063 = sqrt(_17477 / _16317.z);
                float _9068 = sqrt(_17477 / _16317.x);
                float _9082 = (_9063 * _9068) * rsqrt(fma(_9063, _9063, 1.0) * fma(_9068, _9068, 1.0));
                _16349 = float3(_9082 * u_ltc_mag.sample(u_ltc_magSmplr, ((float2(fma(fast::normalize(float3x3(_16304, _16305, _16306) * float3((_8972 * _8958) / fma(_16310, _8970, _17477), (_8977 * _8963) / fma(_16312, _8970, _17477), 1.0)).z, 0.5, 0.5), _9082) * 0.984375) + float2(0.0078125))).w);
                break;
            }
            else
            {
                float3x3 _9122 = float3x3(float3(1.0, 0.0, 0.0), float3(0.0, 1.0, 0.0), float3(0.0, 0.0, 1.0)) * transpose(float3x3(_8730, _8734, _5120));
                float3 _9129 = _9122 * (buffer.u_AreaLightsPoint0[0].xyz - in.v_posWS);
                float3 _9137 = _9122 * (buffer.u_AreaLightsPoint1[0].xyz - in.v_posWS);
                float3 _9145 = _9122 * (buffer.u_AreaLightsPoint2[0].xyz - in.v_posWS);
                float3 _9153 = _9122 * (buffer.u_AreaLightsPoint3[0].xyz - in.v_posWS);
                float _9539 = _9129.z;
                int _17508 = int(_9539 > 0.0);
                float _9546 = _9137.z;
                int _16144;
                if (_9546 > 0.0)
                {
                    _16144 = _17508 + 2;
                }
                else
                {
                    _16144 = _17508;
                }
                float _9553 = _9145.z;
                int _16148;
                if (_9553 > 0.0)
                {
                    _16148 = _16144 + 4;
                }
                else
                {
                    _16148 = _16144;
                }
                float _9560 = _9153.z;
                int _16149;
                if (_9560 > 0.0)
                {
                    _16149 = _16148 + 8;
                }
                else
                {
                    _16149 = _16148;
                }
                int _16160;
                float3 _16176;
                float3 _16196;
                float3 _16218;
                float3 _16236;
                float3 _16254;
                if (_16149 == 0)
                {
                    _16254 = _9137;
                    _16236 = _9145;
                    _16218 = _9153;
                    _16196 = _14537;
                    _16176 = _9129;
                    _16160 = 0;
                }
                else
                {
                    int _16161;
                    float3 _16177;
                    float3 _16201;
                    float3 _16219;
                    float3 _16237;
                    float3 _16255;
                    if (_16149 == 1)
                    {
                        _16255 = (_9129 * (-_9546)) + (_9137 * _9539);
                        _16237 = (_9129 * (-_9560)) + (_9153 * _9539);
                        _16219 = _9153;
                        _16201 = _14537;
                        _16177 = _9129;
                        _16161 = 3;
                    }
                    else
                    {
                        int _16162;
                        float3 _16178;
                        float3 _16202;
                        float3 _16220;
                        float3 _16238;
                        float3 _16256;
                        if (_16149 == 2)
                        {
                            _16256 = _9137;
                            _16238 = (_9137 * (-_9553)) + (_9145 * _9546);
                            _16220 = _9153;
                            _16202 = _14537;
                            _16178 = (_9137 * (-_9539)) + (_9129 * _9546);
                            _16162 = 3;
                        }
                        else
                        {
                            int _16163;
                            float3 _16179;
                            float3 _16203;
                            float3 _16221;
                            float3 _16239;
                            float3 _16257;
                            if (_16149 == 3)
                            {
                                _16257 = _9137;
                                _16239 = (_9137 * (-_9553)) + (_9145 * _9546);
                                _16221 = (_9129 * (-_9560)) + (_9153 * _9539);
                                _16203 = _14537;
                                _16179 = _9129;
                                _16163 = 4;
                            }
                            else
                            {
                                int _16164;
                                float3 _16180;
                                float3 _16204;
                                float3 _16222;
                                float3 _16240;
                                float3 _16258;
                                if (_16149 == 4)
                                {
                                    _16258 = (_9145 * (-_9546)) + (_9137 * _9553);
                                    _16240 = _9145;
                                    _16222 = _9153;
                                    _16204 = _14537;
                                    _16180 = (_9145 * (-_9560)) + (_9153 * _9553);
                                    _16164 = 3;
                                }
                                else
                                {
                                    int _16165;
                                    float3 _16181;
                                    float3 _16205;
                                    float3 _16223;
                                    float3 _16241;
                                    float3 _16259;
                                    if (_16149 == 5)
                                    {
                                        _16259 = _9137;
                                        _16241 = _9145;
                                        _16223 = _9153;
                                        _16205 = _14537;
                                        _16181 = _9129;
                                        _16165 = 0;
                                    }
                                    else
                                    {
                                        int _16166;
                                        float3 _16182;
                                        float3 _16206;
                                        float3 _16224;
                                        float3 _16242;
                                        float3 _16260;
                                        if (_16149 == 6)
                                        {
                                            _16260 = _9137;
                                            _16242 = _9145;
                                            _16224 = (_9145 * (-_9560)) + (_9153 * _9553);
                                            _16206 = _14537;
                                            _16182 = (_9137 * (-_9539)) + (_9129 * _9546);
                                            _16166 = 4;
                                        }
                                        else
                                        {
                                            int _16167;
                                            float3 _16183;
                                            float3 _16207;
                                            float3 _16225;
                                            float3 _16243;
                                            float3 _16261;
                                            if (_16149 == 7)
                                            {
                                                float _9729 = -_9560;
                                                _16261 = _9137;
                                                _16243 = _9145;
                                                _16225 = (_9145 * _9729) + (_9153 * _9553);
                                                _16207 = (_9129 * _9729) + (_9153 * _9539);
                                                _16183 = _9129;
                                                _16167 = 5;
                                            }
                                            else
                                            {
                                                int _16168;
                                                float3 _16184;
                                                float3 _16208;
                                                float3 _16226;
                                                float3 _16244;
                                                float3 _16262;
                                                if (_16149 == 8)
                                                {
                                                    _16262 = (_9153 * (-_9553)) + (_9145 * _9560);
                                                    _16244 = _9153;
                                                    _16226 = _9153;
                                                    _16208 = _14537;
                                                    _16184 = (_9153 * (-_9539)) + (_9129 * _9560);
                                                    _16168 = 3;
                                                }
                                                else
                                                {
                                                    int _16169;
                                                    float3 _16185;
                                                    float3 _16209;
                                                    float3 _16227;
                                                    float3 _16245;
                                                    float3 _16263;
                                                    if (_16149 == 9)
                                                    {
                                                        _16263 = (_9129 * (-_9546)) + (_9137 * _9539);
                                                        _16245 = (_9153 * (-_9553)) + (_9145 * _9560);
                                                        _16227 = _9153;
                                                        _16209 = _14537;
                                                        _16185 = _9129;
                                                        _16169 = 4;
                                                    }
                                                    else
                                                    {
                                                        int _16170;
                                                        float3 _16186;
                                                        float3 _16210;
                                                        float3 _16228;
                                                        float3 _16246;
                                                        float3 _16264;
                                                        if (_16149 == 10)
                                                        {
                                                            _16264 = _9137;
                                                            _16246 = _9145;
                                                            _16228 = _9153;
                                                            _16210 = _14537;
                                                            _16186 = _9129;
                                                            _16170 = 0;
                                                        }
                                                        else
                                                        {
                                                            int _16171;
                                                            float3 _16187;
                                                            float3 _16211;
                                                            float3 _16229;
                                                            float3 _16247;
                                                            float3 _16265;
                                                            if (_16149 == 11)
                                                            {
                                                                float _9829 = -_9553;
                                                                _16265 = _9137;
                                                                _16247 = (_9137 * _9829) + (_9145 * _9546);
                                                                _16229 = (_9153 * _9829) + (_9145 * _9560);
                                                                _16211 = _9153;
                                                                _16187 = _9129;
                                                                _16171 = 5;
                                                            }
                                                            else
                                                            {
                                                                int _16172;
                                                                float3 _16188;
                                                                float3 _16212;
                                                                float3 _16230;
                                                                float3 _16248;
                                                                float3 _16266;
                                                                if (_16149 == 12)
                                                                {
                                                                    _16266 = (_9145 * (-_9546)) + (_9137 * _9553);
                                                                    _16248 = _9145;
                                                                    _16230 = _9153;
                                                                    _16212 = _14537;
                                                                    _16188 = (_9153 * (-_9539)) + (_9129 * _9560);
                                                                    _16172 = 4;
                                                                }
                                                                else
                                                                {
                                                                    bool _9885 = _16149 == 13;
                                                                    int _16173;
                                                                    float3 _16189;
                                                                    float3 _16213;
                                                                    float3 _16249;
                                                                    float3 _16267;
                                                                    if (_9885)
                                                                    {
                                                                        float _9895 = -_9546;
                                                                        _16267 = (_9129 * _9895) + (_9137 * _9539);
                                                                        _16249 = (_9145 * _9895) + (_9137 * _9553);
                                                                        _16213 = _9153;
                                                                        _16189 = _9129;
                                                                        _16173 = 5;
                                                                    }
                                                                    else
                                                                    {
                                                                        int _16174;
                                                                        float3 _16190;
                                                                        float3 _16214;
                                                                        if (_16149 == 14)
                                                                        {
                                                                            float _9925 = -_9539;
                                                                            _16214 = (_9153 * _9925) + (_9129 * _9560);
                                                                            _16190 = (_9137 * _9925) + (_9129 * _9546);
                                                                            _16174 = 5;
                                                                        }
                                                                        else
                                                                        {
                                                                            _16214 = _14537;
                                                                            _16190 = _9129;
                                                                            _16174 = (_16149 == 15) ? 4 : 0;
                                                                        }
                                                                        _16267 = _9137;
                                                                        _16249 = _9145;
                                                                        _16213 = _16214;
                                                                        _16189 = _16190;
                                                                        _16173 = _16174;
                                                                    }
                                                                    _16266 = _16267;
                                                                    _16248 = _16249;
                                                                    _16230 = select(_9153, _9145, bool3(_9885));
                                                                    _16212 = _16213;
                                                                    _16188 = _16189;
                                                                    _16172 = _16173;
                                                                }
                                                                _16265 = _16266;
                                                                _16247 = _16248;
                                                                _16229 = _16230;
                                                                _16211 = _16212;
                                                                _16187 = _16188;
                                                                _16171 = _16172;
                                                            }
                                                            _16264 = _16265;
                                                            _16246 = _16247;
                                                            _16228 = _16229;
                                                            _16210 = _16211;
                                                            _16186 = _16187;
                                                            _16170 = _16171;
                                                        }
                                                        _16263 = _16264;
                                                        _16245 = _16246;
                                                        _16227 = _16228;
                                                        _16209 = _16210;
                                                        _16185 = _16186;
                                                        _16169 = _16170;
                                                    }
                                                    _16262 = _16263;
                                                    _16244 = _16245;
                                                    _16226 = _16227;
                                                    _16208 = _16209;
                                                    _16184 = _16185;
                                                    _16168 = _16169;
                                                }
                                                _16261 = _16262;
                                                _16243 = _16244;
                                                _16225 = _16226;
                                                _16207 = _16208;
                                                _16183 = _16184;
                                                _16167 = _16168;
                                            }
                                            _16260 = _16261;
                                            _16242 = _16243;
                                            _16224 = _16225;
                                            _16206 = _16207;
                                            _16182 = _16183;
                                            _16166 = _16167;
                                        }
                                        _16259 = _16260;
                                        _16241 = _16242;
                                        _16223 = _16224;
                                        _16205 = _16206;
                                        _16181 = _16182;
                                        _16165 = _16166;
                                    }
                                    _16258 = _16259;
                                    _16240 = _16241;
                                    _16222 = _16223;
                                    _16204 = _16205;
                                    _16180 = _16181;
                                    _16164 = _16165;
                                }
                                _16257 = _16258;
                                _16239 = _16240;
                                _16221 = _16222;
                                _16203 = _16204;
                                _16179 = _16180;
                                _16163 = _16164;
                            }
                            _16256 = _16257;
                            _16238 = _16239;
                            _16220 = _16221;
                            _16202 = _16203;
                            _16178 = _16179;
                            _16162 = _16163;
                        }
                        _16255 = _16256;
                        _16237 = _16238;
                        _16219 = _16220;
                        _16201 = _16202;
                        _16177 = _16178;
                        _16161 = _16162;
                    }
                    _16254 = _16255;
                    _16236 = _16237;
                    _16218 = _16219;
                    _16196 = _16201;
                    _16176 = _16177;
                    _16160 = _16161;
                }
                if (_16160 == 0)
                {
                    _16349 = float3(0.0);
                    break;
                }
                float3 _9165 = fast::normalize(_16176);
                float3 _9169 = fast::normalize(_16254);
                float3 _9173 = fast::normalize(_16236);
                float3 _9177 = fast::normalize(select(_16218, _16176, bool3(_16160 == 3)));
                float3 _9181 = fast::normalize(select(_16196, _16176, bool3(_16160 == 4)));
                float _10002 = dot(_9165, _9169);
                float _10004 = abs(_10002);
                float _10018 = fma(fma(0.01452060043811798095703125, _10004, 0.4965155124664306640625), _10004, 0.8543984889984130859375) / fma(4.1616725921630859375 + _10004, _10004, 3.41759395599365234375);
                float _16272;
                if (_10002 > 0.0)
                {
                    _16272 = _10018;
                }
                else
                {
                    _16272 = fma(0.5, rsqrt(fast::max(fma(-_10002, _10002, 1.0), 1.0000000116860974230803549289703e-07)), -_10018);
                }
                float _10059 = dot(_9169, _9173);
                float _10061 = abs(_10059);
                float _10075 = fma(fma(0.01452060043811798095703125, _10061, 0.4965155124664306640625), _10061, 0.8543984889984130859375) / fma(4.1616725921630859375 + _10061, _10061, 3.41759395599365234375);
                float _16276;
                if (_10059 > 0.0)
                {
                    _16276 = _10075;
                }
                else
                {
                    _16276 = fma(0.5, rsqrt(fast::max(fma(-_10059, _10059, 1.0), 1.0000000116860974230803549289703e-07)), -_10075);
                }
                float _10116 = dot(_9173, _9177);
                float _10118 = abs(_10116);
                float _10132 = fma(fma(0.01452060043811798095703125, _10118, 0.4965155124664306640625), _10118, 0.8543984889984130859375) / fma(4.1616725921630859375 + _10118, _10118, 3.41759395599365234375);
                float _16281;
                if (_10116 > 0.0)
                {
                    _16281 = _10132;
                }
                else
                {
                    _16281 = fma(0.5, rsqrt(fast::max(fma(-_10116, _10116, 1.0), 1.0000000116860974230803549289703e-07)), -_10132);
                }
                float _9203 = ((cross(_9165, _9169) * _16272).z + (cross(_9169, _9173) * _16276).z) + (cross(_9173, _9177) * _16281).z;
                float _16298;
                if (_16160 >= 4)
                {
                    float _10173 = dot(_9177, _9181);
                    float _10175 = abs(_10173);
                    float _10189 = fma(fma(0.01452060043811798095703125, _10175, 0.4965155124664306640625), _10175, 0.8543984889984130859375) / fma(4.1616725921630859375 + _10175, _10175, 3.41759395599365234375);
                    float _16287;
                    if (_10173 > 0.0)
                    {
                        _16287 = _10189;
                    }
                    else
                    {
                        _16287 = fma(0.5, rsqrt(fast::max(fma(-_10173, _10173, 1.0), 1.0000000116860974230803549289703e-07)), -_10189);
                    }
                    _16298 = _9203 + (cross(_9177, _9181) * _16287).z;
                }
                else
                {
                    _16298 = _9203;
                }
                float _16299;
                if (_16160 == 5)
                {
                    float _10230 = dot(_9181, _9165);
                    float _10232 = abs(_10230);
                    float _10246 = fma(fma(0.01452060043811798095703125, _10232, 0.4965155124664306640625), _10232, 0.8543984889984130859375) / fma(4.1616725921630859375 + _10232, _10232, 3.41759395599365234375);
                    float _16296;
                    if (_10230 > 0.0)
                    {
                        _16296 = _10246;
                    }
                    else
                    {
                        _16296 = fma(0.5, rsqrt(fast::max(fma(-_10230, _10230, 1.0), 1.0000000116860974230803549289703e-07)), -_10246);
                    }
                    _16299 = _16298 + (cross(_9181, _9165) * _16296).z;
                }
                else
                {
                    _16299 = _16298;
                }
                if (buffer.u_AreaLightsTwoSide[0] > 0.5)
                {
                    _16349 = float3(abs(_16299));
                    break;
                }
                _16349 = float3(fast::max(0.0, _16299));
                break;
            }
        } while(false);
        float2 _10290 = fast::clamp((float2(0.5, sqrt(1.0 - _5154)) * 0.984375) + float2(0.0078125), float2(0.0), float2(1.0));
        float4 _10350 = u_ltc_mat.sample(u_ltc_matSmplr, _10290);
        float4 _10354 = (_10350 - float4(0.5)) * 4.0;
        float3x3 _10377 = float3x3(float3(_10354.x, 0.0, _10354.y), float3(0.0, 1.0, 0.0), float3(_10354.z, 0.0, _10354.w));
        float4 _10383 = u_ltc_mag.sample(u_ltc_magSmplr, _10290);
        float3 _16661;
        do
        {
            if (_8737)
            {
                float3x3 _10485 = transpose(float3x3(_8730, _8734, _5120));
                float3 _10492 = _10485 * (buffer.u_AreaLightsPoint0[0].xyz - in.v_posWS);
                float3 _10500 = _10485 * (buffer.u_AreaLightsPoint1[0].xyz - in.v_posWS);
                float3 _10508 = _10485 * (buffer.u_AreaLightsPoint2[0].xyz - in.v_posWS);
                float3 _10530 = _10377 * ((_10492 + _10508) * 0.5);
                float3 _10533 = _10377 * ((_10500 - _10508) * 0.5);
                float3 _10536 = _10377 * ((_10500 - _10492) * 0.5);
                if (buffer.u_AreaLightsTwoSide[0] < 0.5)
                {
                    if (dot(cross(_10533, _10536), _10530) < 0.0)
                    {
                        _16661 = float3(0.0);
                        break;
                    }
                }
                float _10552 = dot(_10533, _10533);
                float _10555 = dot(_10536, _10536);
                float _10558 = dot(_10533, _10536);
                float _10563 = _10552 * _10555;
                float3 _16616;
                float3 _16617;
                float _16622;
                float _16624;
                if ((abs(_10558) / sqrt(_10563)) > 9.9999997473787516355514526367188e-05)
                {
                    float _10570 = _10552 + _10555;
                    float _10580 = sqrt(fma(-_10558, _10558, _10563));
                    float _10585 = sqrt(fma(-2.0, _10580, _10570));
                    float _10591 = sqrt(fma(2.0, _10580, _10570));
                    float _10595 = fma(0.5, _10585, 0.5 * _10591);
                    float _10599 = fma(0.5, _10585, _10591 * (-0.5));
                    float3 _16614;
                    float3 _16615;
                    if (_10552 > _10555)
                    {
                        float3 _10607 = _10533 * _10558;
                        float _17493 = -_10552;
                        _16615 = _10607 + (_10536 * fma(_10599, _10599, _17493));
                        _16614 = _10607 + (_10536 * fma(_10595, _10595, _17493));
                    }
                    else
                    {
                        float3 _10626 = _10536 * _10558;
                        float _17491 = -_10555;
                        _16615 = _10626 + (_10533 * fma(_10599, _10599, _17491));
                        _16614 = _10626 + (_10533 * fma(_10595, _10595, _17491));
                    }
                    _16624 = 1.0 / (_10599 * _10599);
                    _16622 = 1.0 / (_10595 * _10595);
                    _16617 = fast::normalize(_16615);
                    _16616 = fast::normalize(_16614);
                }
                else
                {
                    float _10655 = 1.0 / _10552;
                    float _10659 = 1.0 / _10555;
                    _16624 = _10659;
                    _16622 = _10655;
                    _16617 = _10536 * sqrt(_10659);
                    _16616 = _10533 * sqrt(_10655);
                }
                float3 _10671 = cross(_16616, _16617);
                float3 _16618;
                if (dot(_10530, _10671) < 0.0)
                {
                    _16618 = _10671 * (-1.0);
                }
                else
                {
                    _16618 = _10671;
                }
                float _10682 = dot(_16618, _10530);
                float _10687 = dot(_16616, _10530) / _10682;
                float _10692 = dot(_16617, _10530) / _10682;
                float _10699 = _10682 * _10682;
                float _10701 = _16622 * _10699;
                float _10706 = _16624 * _10699;
                float _10709 = _10701 * _10706;
                float _10716 = fma(_10687, _10687, 1.0);
                float _17495 = -_10701;
                float4 _14422 = _17507;
                _14422.x = _10709;
                float4 _14424 = _14422;
                _14424.y = fma(-_16624, _10699, fma(_10709, fma(_10692, _10692, _10716), _17495));
                float4 _14426 = _14424;
                _14426.z = fma(-_10706, fma(_10692, _10692, 1.0), fma(_17495, _10716, 1.0));
                float2 _11023 = _14426.yz * float2(0.3333333432674407958984375);
                float _11025 = _11023.x;
                float4 _14428 = _14426;
                _14428.y = _11025;
                float _11027 = _11023.y;
                float _11038 = -_11027;
                float _11044 = fma(_11038, _11027, _11025);
                float _11047 = -_11025;
                float _11053 = fma(_11047, _11027, _10709);
                float _11062 = dot(float2(_11027, _11047), _14428.xy);
                float _11085 = sqrt(dot(float2(4.0 * _11044, -_11053), float3(_11044, _11053, _11062).zy));
                float _11088 = precise::atan2(_11085, -fma((-2.0) * _11027, _11044, _11053));
                float _11093 = 2.0 * sqrt(-_11044);
                float _11095 = cos(_11088 * 0.3333333432674407958984375);
                float _11104 = _11093 * cos(fma(_11088, 0.3333333432674407958984375, 2.094395160675048828125));
                float _11118 = ((fma(_11093, _11095, _11104) > (2.0 * _11027)) ? (_11093 * _11095) : _11104) - _11027;
                float _11125 = -_10709;
                float _11130 = 2.0 * _11025;
                float _11141 = precise::atan2(_10709 * _11085, -fma(_11125, _11053, _11130 * _11062));
                float _11146 = 2.0 * sqrt(-_11062);
                float _11148 = cos(_11141 * 0.3333333432674407958984375);
                float _11157 = _11146 * cos(fma(_11141, 0.3333333432674407958984375, 2.094395160675048828125));
                float _11173 = ((fma(_11146, _11148, _11157) < _11130) ? (_11146 * _11148) : _11157) + _11025;
                float _11191 = fma(-_11118, _11173, _10709);
                float _11217 = _11125 / _11173;
                float _11222 = fma(_11025, _11191, -(_11027 * (_11118 * _11125))) / fma(_11038, _11191, _11025 * _11173);
                float3 _11228 = float3(_11217, _11222, _11118);
                bool _11233 = _11217 < _11222;
                bool _11241;
                if (_11233)
                {
                    _11241 = _11217 < _11118;
                }
                else
                {
                    _11241 = _11233;
                }
                float3 _16629;
                if (_11241)
                {
                    _16629 = _11228.yxz;
                }
                else
                {
                    bool _11250 = _11118 < _11217;
                    bool _11258;
                    if (_11250)
                    {
                        _11258 = _11118 < _11222;
                    }
                    else
                    {
                        _11258 = _11250;
                    }
                    float3 _16630;
                    if (_11258)
                    {
                        _16630 = _11228.xzy;
                    }
                    else
                    {
                        _16630 = _11228;
                    }
                    _16629 = _16630;
                }
                float _17501 = -_16629.y;
                float _10792 = sqrt(_17501 / _16629.z);
                float _10797 = sqrt(_17501 / _16629.x);
                float _10811 = (_10792 * _10797) * rsqrt(fma(_10792, _10792, 1.0) * fma(_10797, _10797, 1.0));
                _16661 = float3(_10811 * u_ltc_mag.sample(u_ltc_magSmplr, ((float2(fma(fast::normalize(float3x3(_16616, _16617, _16618) * float3((_10701 * _10687) / fma(_16622, _10699, _17501), (_10706 * _10692) / fma(_16624, _10699, _17501), 1.0)).z, 0.5, 0.5), _10811) * 0.984375) + float2(0.0078125))).w);
                break;
            }
            else
            {
                float3x3 _10851 = _10377 * transpose(float3x3(_8730, _8734, _5120));
                float3 _10858 = _10851 * (buffer.u_AreaLightsPoint0[0].xyz - in.v_posWS);
                float3 _10866 = _10851 * (buffer.u_AreaLightsPoint1[0].xyz - in.v_posWS);
                float3 _10874 = _10851 * (buffer.u_AreaLightsPoint2[0].xyz - in.v_posWS);
                float3 _10882 = _10851 * (buffer.u_AreaLightsPoint3[0].xyz - in.v_posWS);
                float _11268 = _10858.z;
                int _17519 = int(_11268 > 0.0);
                float _11275 = _10866.z;
                int _16456;
                if (_11275 > 0.0)
                {
                    _16456 = _17519 + 2;
                }
                else
                {
                    _16456 = _17519;
                }
                float _11282 = _10874.z;
                int _16460;
                if (_11282 > 0.0)
                {
                    _16460 = _16456 + 4;
                }
                else
                {
                    _16460 = _16456;
                }
                float _11289 = _10882.z;
                int _16461;
                if (_11289 > 0.0)
                {
                    _16461 = _16460 + 8;
                }
                else
                {
                    _16461 = _16460;
                }
                int _16472;
                float3 _16488;
                float3 _16508;
                float3 _16530;
                float3 _16548;
                float3 _16566;
                if (_16461 == 0)
                {
                    _16566 = _10866;
                    _16548 = _10874;
                    _16530 = _10882;
                    _16508 = _14537;
                    _16488 = _10858;
                    _16472 = 0;
                }
                else
                {
                    int _16473;
                    float3 _16489;
                    float3 _16513;
                    float3 _16531;
                    float3 _16549;
                    float3 _16567;
                    if (_16461 == 1)
                    {
                        _16567 = (_10858 * (-_11275)) + (_10866 * _11268);
                        _16549 = (_10858 * (-_11289)) + (_10882 * _11268);
                        _16531 = _10882;
                        _16513 = _14537;
                        _16489 = _10858;
                        _16473 = 3;
                    }
                    else
                    {
                        int _16474;
                        float3 _16490;
                        float3 _16514;
                        float3 _16532;
                        float3 _16550;
                        float3 _16568;
                        if (_16461 == 2)
                        {
                            _16568 = _10866;
                            _16550 = (_10866 * (-_11282)) + (_10874 * _11275);
                            _16532 = _10882;
                            _16514 = _14537;
                            _16490 = (_10866 * (-_11268)) + (_10858 * _11275);
                            _16474 = 3;
                        }
                        else
                        {
                            int _16475;
                            float3 _16491;
                            float3 _16515;
                            float3 _16533;
                            float3 _16551;
                            float3 _16569;
                            if (_16461 == 3)
                            {
                                _16569 = _10866;
                                _16551 = (_10866 * (-_11282)) + (_10874 * _11275);
                                _16533 = (_10858 * (-_11289)) + (_10882 * _11268);
                                _16515 = _14537;
                                _16491 = _10858;
                                _16475 = 4;
                            }
                            else
                            {
                                int _16476;
                                float3 _16492;
                                float3 _16516;
                                float3 _16534;
                                float3 _16552;
                                float3 _16570;
                                if (_16461 == 4)
                                {
                                    _16570 = (_10874 * (-_11275)) + (_10866 * _11282);
                                    _16552 = _10874;
                                    _16534 = _10882;
                                    _16516 = _14537;
                                    _16492 = (_10874 * (-_11289)) + (_10882 * _11282);
                                    _16476 = 3;
                                }
                                else
                                {
                                    int _16477;
                                    float3 _16493;
                                    float3 _16517;
                                    float3 _16535;
                                    float3 _16553;
                                    float3 _16571;
                                    if (_16461 == 5)
                                    {
                                        _16571 = _10866;
                                        _16553 = _10874;
                                        _16535 = _10882;
                                        _16517 = _14537;
                                        _16493 = _10858;
                                        _16477 = 0;
                                    }
                                    else
                                    {
                                        int _16478;
                                        float3 _16494;
                                        float3 _16518;
                                        float3 _16536;
                                        float3 _16554;
                                        float3 _16572;
                                        if (_16461 == 6)
                                        {
                                            _16572 = _10866;
                                            _16554 = _10874;
                                            _16536 = (_10874 * (-_11289)) + (_10882 * _11282);
                                            _16518 = _14537;
                                            _16494 = (_10866 * (-_11268)) + (_10858 * _11275);
                                            _16478 = 4;
                                        }
                                        else
                                        {
                                            int _16479;
                                            float3 _16495;
                                            float3 _16519;
                                            float3 _16537;
                                            float3 _16555;
                                            float3 _16573;
                                            if (_16461 == 7)
                                            {
                                                float _11458 = -_11289;
                                                _16573 = _10866;
                                                _16555 = _10874;
                                                _16537 = (_10874 * _11458) + (_10882 * _11282);
                                                _16519 = (_10858 * _11458) + (_10882 * _11268);
                                                _16495 = _10858;
                                                _16479 = 5;
                                            }
                                            else
                                            {
                                                int _16480;
                                                float3 _16496;
                                                float3 _16520;
                                                float3 _16538;
                                                float3 _16556;
                                                float3 _16574;
                                                if (_16461 == 8)
                                                {
                                                    _16574 = (_10882 * (-_11282)) + (_10874 * _11289);
                                                    _16556 = _10882;
                                                    _16538 = _10882;
                                                    _16520 = _14537;
                                                    _16496 = (_10882 * (-_11268)) + (_10858 * _11289);
                                                    _16480 = 3;
                                                }
                                                else
                                                {
                                                    int _16481;
                                                    float3 _16497;
                                                    float3 _16521;
                                                    float3 _16539;
                                                    float3 _16557;
                                                    float3 _16575;
                                                    if (_16461 == 9)
                                                    {
                                                        _16575 = (_10858 * (-_11275)) + (_10866 * _11268);
                                                        _16557 = (_10882 * (-_11282)) + (_10874 * _11289);
                                                        _16539 = _10882;
                                                        _16521 = _14537;
                                                        _16497 = _10858;
                                                        _16481 = 4;
                                                    }
                                                    else
                                                    {
                                                        int _16482;
                                                        float3 _16498;
                                                        float3 _16522;
                                                        float3 _16540;
                                                        float3 _16558;
                                                        float3 _16576;
                                                        if (_16461 == 10)
                                                        {
                                                            _16576 = _10866;
                                                            _16558 = _10874;
                                                            _16540 = _10882;
                                                            _16522 = _14537;
                                                            _16498 = _10858;
                                                            _16482 = 0;
                                                        }
                                                        else
                                                        {
                                                            int _16483;
                                                            float3 _16499;
                                                            float3 _16523;
                                                            float3 _16541;
                                                            float3 _16559;
                                                            float3 _16577;
                                                            if (_16461 == 11)
                                                            {
                                                                float _11558 = -_11282;
                                                                _16577 = _10866;
                                                                _16559 = (_10866 * _11558) + (_10874 * _11275);
                                                                _16541 = (_10882 * _11558) + (_10874 * _11289);
                                                                _16523 = _10882;
                                                                _16499 = _10858;
                                                                _16483 = 5;
                                                            }
                                                            else
                                                            {
                                                                int _16484;
                                                                float3 _16500;
                                                                float3 _16524;
                                                                float3 _16542;
                                                                float3 _16560;
                                                                float3 _16578;
                                                                if (_16461 == 12)
                                                                {
                                                                    _16578 = (_10874 * (-_11275)) + (_10866 * _11282);
                                                                    _16560 = _10874;
                                                                    _16542 = _10882;
                                                                    _16524 = _14537;
                                                                    _16500 = (_10882 * (-_11268)) + (_10858 * _11289);
                                                                    _16484 = 4;
                                                                }
                                                                else
                                                                {
                                                                    bool _11614 = _16461 == 13;
                                                                    int _16485;
                                                                    float3 _16501;
                                                                    float3 _16525;
                                                                    float3 _16561;
                                                                    float3 _16579;
                                                                    if (_11614)
                                                                    {
                                                                        float _11624 = -_11275;
                                                                        _16579 = (_10858 * _11624) + (_10866 * _11268);
                                                                        _16561 = (_10874 * _11624) + (_10866 * _11282);
                                                                        _16525 = _10882;
                                                                        _16501 = _10858;
                                                                        _16485 = 5;
                                                                    }
                                                                    else
                                                                    {
                                                                        int _16486;
                                                                        float3 _16502;
                                                                        float3 _16526;
                                                                        if (_16461 == 14)
                                                                        {
                                                                            float _11654 = -_11268;
                                                                            _16526 = (_10882 * _11654) + (_10858 * _11289);
                                                                            _16502 = (_10866 * _11654) + (_10858 * _11275);
                                                                            _16486 = 5;
                                                                        }
                                                                        else
                                                                        {
                                                                            _16526 = _14537;
                                                                            _16502 = _10858;
                                                                            _16486 = (_16461 == 15) ? 4 : 0;
                                                                        }
                                                                        _16579 = _10866;
                                                                        _16561 = _10874;
                                                                        _16525 = _16526;
                                                                        _16501 = _16502;
                                                                        _16485 = _16486;
                                                                    }
                                                                    _16578 = _16579;
                                                                    _16560 = _16561;
                                                                    _16542 = select(_10882, _10874, bool3(_11614));
                                                                    _16524 = _16525;
                                                                    _16500 = _16501;
                                                                    _16484 = _16485;
                                                                }
                                                                _16577 = _16578;
                                                                _16559 = _16560;
                                                                _16541 = _16542;
                                                                _16523 = _16524;
                                                                _16499 = _16500;
                                                                _16483 = _16484;
                                                            }
                                                            _16576 = _16577;
                                                            _16558 = _16559;
                                                            _16540 = _16541;
                                                            _16522 = _16523;
                                                            _16498 = _16499;
                                                            _16482 = _16483;
                                                        }
                                                        _16575 = _16576;
                                                        _16557 = _16558;
                                                        _16539 = _16540;
                                                        _16521 = _16522;
                                                        _16497 = _16498;
                                                        _16481 = _16482;
                                                    }
                                                    _16574 = _16575;
                                                    _16556 = _16557;
                                                    _16538 = _16539;
                                                    _16520 = _16521;
                                                    _16496 = _16497;
                                                    _16480 = _16481;
                                                }
                                                _16573 = _16574;
                                                _16555 = _16556;
                                                _16537 = _16538;
                                                _16519 = _16520;
                                                _16495 = _16496;
                                                _16479 = _16480;
                                            }
                                            _16572 = _16573;
                                            _16554 = _16555;
                                            _16536 = _16537;
                                            _16518 = _16519;
                                            _16494 = _16495;
                                            _16478 = _16479;
                                        }
                                        _16571 = _16572;
                                        _16553 = _16554;
                                        _16535 = _16536;
                                        _16517 = _16518;
                                        _16493 = _16494;
                                        _16477 = _16478;
                                    }
                                    _16570 = _16571;
                                    _16552 = _16553;
                                    _16534 = _16535;
                                    _16516 = _16517;
                                    _16492 = _16493;
                                    _16476 = _16477;
                                }
                                _16569 = _16570;
                                _16551 = _16552;
                                _16533 = _16534;
                                _16515 = _16516;
                                _16491 = _16492;
                                _16475 = _16476;
                            }
                            _16568 = _16569;
                            _16550 = _16551;
                            _16532 = _16533;
                            _16514 = _16515;
                            _16490 = _16491;
                            _16474 = _16475;
                        }
                        _16567 = _16568;
                        _16549 = _16550;
                        _16531 = _16532;
                        _16513 = _16514;
                        _16489 = _16490;
                        _16473 = _16474;
                    }
                    _16566 = _16567;
                    _16548 = _16549;
                    _16530 = _16531;
                    _16508 = _16513;
                    _16488 = _16489;
                    _16472 = _16473;
                }
                if (_16472 == 0)
                {
                    _16661 = float3(0.0);
                    break;
                }
                float3 _10894 = fast::normalize(_16488);
                float3 _10898 = fast::normalize(_16566);
                float3 _10902 = fast::normalize(_16548);
                float3 _10906 = fast::normalize(select(_16530, _16488, bool3(_16472 == 3)));
                float3 _10910 = fast::normalize(select(_16508, _16488, bool3(_16472 == 4)));
                float _11731 = dot(_10894, _10898);
                float _11733 = abs(_11731);
                float _11747 = fma(fma(0.01452060043811798095703125, _11733, 0.4965155124664306640625), _11733, 0.8543984889984130859375) / fma(4.1616725921630859375 + _11733, _11733, 3.41759395599365234375);
                float _16584;
                if (_11731 > 0.0)
                {
                    _16584 = _11747;
                }
                else
                {
                    _16584 = fma(0.5, rsqrt(fast::max(fma(-_11731, _11731, 1.0), 1.0000000116860974230803549289703e-07)), -_11747);
                }
                float _11788 = dot(_10898, _10902);
                float _11790 = abs(_11788);
                float _11804 = fma(fma(0.01452060043811798095703125, _11790, 0.4965155124664306640625), _11790, 0.8543984889984130859375) / fma(4.1616725921630859375 + _11790, _11790, 3.41759395599365234375);
                float _16588;
                if (_11788 > 0.0)
                {
                    _16588 = _11804;
                }
                else
                {
                    _16588 = fma(0.5, rsqrt(fast::max(fma(-_11788, _11788, 1.0), 1.0000000116860974230803549289703e-07)), -_11804);
                }
                float _11845 = dot(_10902, _10906);
                float _11847 = abs(_11845);
                float _11861 = fma(fma(0.01452060043811798095703125, _11847, 0.4965155124664306640625), _11847, 0.8543984889984130859375) / fma(4.1616725921630859375 + _11847, _11847, 3.41759395599365234375);
                float _16593;
                if (_11845 > 0.0)
                {
                    _16593 = _11861;
                }
                else
                {
                    _16593 = fma(0.5, rsqrt(fast::max(fma(-_11845, _11845, 1.0), 1.0000000116860974230803549289703e-07)), -_11861);
                }
                float _10932 = ((cross(_10894, _10898) * _16584).z + (cross(_10898, _10902) * _16588).z) + (cross(_10902, _10906) * _16593).z;
                float _16610;
                if (_16472 >= 4)
                {
                    float _11902 = dot(_10906, _10910);
                    float _11904 = abs(_11902);
                    float _11918 = fma(fma(0.01452060043811798095703125, _11904, 0.4965155124664306640625), _11904, 0.8543984889984130859375) / fma(4.1616725921630859375 + _11904, _11904, 3.41759395599365234375);
                    float _16599;
                    if (_11902 > 0.0)
                    {
                        _16599 = _11918;
                    }
                    else
                    {
                        _16599 = fma(0.5, rsqrt(fast::max(fma(-_11902, _11902, 1.0), 1.0000000116860974230803549289703e-07)), -_11918);
                    }
                    _16610 = _10932 + (cross(_10906, _10910) * _16599).z;
                }
                else
                {
                    _16610 = _10932;
                }
                float _16611;
                if (_16472 == 5)
                {
                    float _11959 = dot(_10910, _10894);
                    float _11961 = abs(_11959);
                    float _11975 = fma(fma(0.01452060043811798095703125, _11961, 0.4965155124664306640625), _11961, 0.8543984889984130859375) / fma(4.1616725921630859375 + _11961, _11961, 3.41759395599365234375);
                    float _16608;
                    if (_11959 > 0.0)
                    {
                        _16608 = _11975;
                    }
                    else
                    {
                        _16608 = fma(0.5, rsqrt(fast::max(fma(-_11959, _11959, 1.0), 1.0000000116860974230803549289703e-07)), -_11975);
                    }
                    _16611 = _16610 + (cross(_10910, _10894) * _16608).z;
                }
                else
                {
                    _16611 = _16610;
                }
                if (buffer.u_AreaLightsTwoSide[0] > 0.5)
                {
                    _16661 = float3(abs(_16611));
                    break;
                }
                _16661 = float3(fast::max(0.0, _16611));
                break;
            }
        } while(false);
        _16796 = _16007 + (((buffer.u_AreaLightsColor[0].xyz * _8570) * (((float3(0.951999962329864501953125) * _10383.x) + (float3(0.048000037670135498046875) * _10383.y)) * _16661)) * 1.0);
        _16755 = _16006 + ((((float3(0.050000011920928955078125) * buffer.u_AreaLightsColor[0].xyz) * _8570) * _16349) * 1.0);
    }
    else
    {
        _16796 = _16007;
        _16755 = _16006;
    }
    float _12019 = (buffer.u_AreaLightsIntensity[1] * buffer.u_AreaLightsEnabled[1]) * 3.1415920257568359375;
    float3 _17312;
    float3 _17313;
    if (buffer.u_AreaLightsEnabled[1] > 0.5)
    {
        float _12172 = 1.0 - fast::max(0.0, _14536);
        float _12186 = _12172 * _12172;
        float _12204 = fma(fma(_14536, 0.0625, -_14536), _14536, 1.0);
        _17313 = _16796 + (((((float3(0.951999962329864501953125) + (float3(0.048000037670135498046875) * ((_12186 * _12186) * _12172))) * (0.00497359223663806915283203125 / fma(_12204, _12204, 1.0000000116860974230803549289703e-07))) * _14536) * buffer.u_AreaLightsColor[1].xyz) * _12019);
        _17312 = _16755 + (((float3(0.050000011920928955078125) * buffer.u_AreaLightsColor[1].xyz) * _12019) * (_14536 * 0.31830990314483642578125));
    }
    else
    {
        _17313 = _16796;
        _17312 = _16755;
    }
    float4 _5038 = float4((_17312 + (float4(pow(fast::max(buffer._Custom_Color.xyz, float3(9.9999997473787516355514526367188e-06)), float3(2.2000000476837158203125)), _17506).xyz * smoothstep((-1.0) * buffer._Custom_Float_2, buffer._Custom_Float_2, buffer._Custom_Float_3 + _3994))) + _17313, smoothstep(-0.00999999977648258209228515625, 0.00999999977648258209228515625, _3994 * (-1.0)));
    float3 _12226 = pow(fast::max(_5038.xyz, float3(9.9999997473787516355514526367188e-06)), float3(0.4545454680919647216796875));
    float4 _14531 = _5038;
    _14531.x = _12226.x;
    float4 _14533 = _14531;
    _14533.y = _12226.y;
    float4 _14535 = _14533;
    _14535.z = _12226.z;
    out.o_FragColor = _14535;
    return out;
}

