# ChangeLog

## Current

**EffectSDK Requirement**: 1050 (modify if introduce breaking change)

### Features

### Bug Fixes

## 5.7.0

**EffectSDK Requirement**: 1050

### Features

* Rollback scene object reference support for EHI (from 12.9.0 to 12.8.0)

* Disable platformios12.8.0.4-Douyin unit test 

### Bug Fixes

## 5.6.1

**EffectSDK Requirement**: 1050

### Bug Fixes

* Rename FaceID to pass security check

## 5.6.0

**EffectSDK Requirement**: 1050

### Features

* feature: Add Tiktok Lite support

### Bug Fixes

* Add UnitTest for algorithms

## 5.5.0

**EffectSDK Requirement**: 1050

### Features

* feat(filter): Add new filter node (neural network filter node).

### Bug Fixes

* fix(algorithm): Fix hand's segmentation mask texture (look bad in metal-backend).

## 5.4.0

**EffectSDK Requirement**: 1050

### Bug Fixes

* fix(algorithm): Fix algorithm results. Create safeguards for all types of algorithms.

### Features

* feat(render-api): Implemented base rendering api wrapper for amazing js.

## 5.3.0

**EffectSDK Requirement**: 1050

### Features

* feat(engine): Support loading resource from asset's alias path.

## 5.2.1

**EffectSDK Requirement**: 1050

### Bug Fixes

* fix(script): Support multiple script components in one sceneObject.

## 5.2.0

**EffectSDK Requirement**: 1050

### Features

* feat(engine): Expose minimum sdk version api

## 5.1.0

**EffectSDK Requirement**: 1050

### Features

* feat(js-analytics): Add Analytics API for Amazing JS. See [API Design](https://bytedance.us.feishu.cn/docx/doxcnQeQZgPhsIUR76YOajK20ad). Minimal SDK version for this feature is 1200.
* Added API to access Amazing JS version and SDK version through the Engine API

## 5.0.0

**EffectSDK Requirement**: 1050

### Features

* feat(head-api): Modify head api to be more user-friendly. See [API Design](https://bytedance.feishu.cn/docx/doxcnBU1e8Q2jcgbSuwGE9CHFSd) and [Upgrade Instructions](https://bytedance.feishu.cn/wiki/wikcnvGbsZJs6340wPhGEoiddpW)

## 4.1.0

**EffectSDK Requirement**: 1050

### Features

* feat(prefab): Add prefab API to load prefab and create prefab instances.

## 4.0.0

**EffectSDK Requirement**: 1050

### Features

* feat(math): Memory Mapping Math Library (requires Effect SDK 1170 to get the performance boost, compatible with the previous Effect SDK).

### Bug Fixes

* fix(algorithm): fix the pet's signs of roll, yaw, and pitch for head API.

## 3.1.0

**EffectSDK Requirement**: 1050

### Features

* feat(algorithm): Add face contour algorithm to Head API.

## 3.0.1

**EffectSDK Requirement**: 1050

### Bug Fixes

* fix(unittest): fix scene unit test for Amazing Editor after 1140.
* fix: Update README and gitignore

## 3.0.0

**EffectSDK Requirement**: 1050

### Features

* feat(core): align core API with Orion's UI (change amg.Entity to amg.SceneObject). See [Upgrade Instructions](https://bytedance.feishu.cn/wiki/wikcnvGbsZJs6340wPhGEoiddpW).
* feat(core): enhance core API: change amg.Script to amg.ScriptComponent, change amg.Engine.engine to amg.Engine. See [Upgrade Instructions](https://bytedance.feishu.cn/wiki/wikcnvGbsZJs6340wPhGEoiddpW).
* feat(core): use component/class name to look up for component (add, get, has, find, remove). See [Upgrade Instructions](https://bytedance.feishu.cn/wiki/wikcnvGbsZJs6340wPhGEoiddpW).
* feat(filter): added uniforms support for OperatorFiler.

### Bug Fixes

## 2.1.0

**EffectSDK Requirement**: 1010

### Features

* feat(pet): support pet faces in Head API.
* [Require 1120] feat(amazingjs): add audio controller wrapper.

### Bug Fixes

* fix: add version guarding for audio and gesture module.
* fix: add usability checks for body2d's action recognition

## 2.0.0

**EffectSDK Requirement**: 1100

### Features

* feat: add gesture module (requires 1100). See [API Design](https://bytedance.feishu.cn/docs/doccnqWintqkQS7NX65EWvZFRyh#mLpyUO).
* feat: Custom Asset supports [Image Picker](https://bytedance.feishu.cn/docx/doxcnUyeUw8bPIbhjFRXcPeegcg).
* feat: add hand segmentation for Custom Asset

## 1.1.3

**EffectSDK Requirement**: 1010

### Bug Fixes

* fix(filter): Fixed button & slider thumb component bug: update eventType ID

## 1.1.2

**EffectSDK Requirement**: 1010

### Bug Fixes

* fix(filter): Fixed grow filter's blank bug: pingpong unmatching size

## 1.1.1

**EffectSDK Requirement**: 1010

### Bug Fixes

* fix(segmentation): add back premultiply for segmentation asset

## 1.1.0

**EffectSDK Requirement**: 1010

### Features

* feat: add HandSegProvider method to Segmentation

## 1.0.1

**EffectSDK Requirement**: 1010

### Features

* doc: Update jsdocs for JS Filter.

* feat: Use alias instead of native Amaz.types (breaking API change) see more in <https://bytedance.feishu.cn/docx/doxcnqqnC0ugNKro536k6Jvz0Vg>

## 1.0.0

**EffectSDK Requirement**: 1010

### Features

* feat: refactor FilterSystem (breaking API) see more in <https://bytedance.feishu.cn/docs/doccnLeRju8Sh753uLmTxERL6xb> and <https://bytedance.feishu.cn/docs/doccnQ6aQiejx4jf8Jn5zlmMFWg>

## 0.5.0

**EffectSDK Requirement**: 1010

### Features

* feat: add hasComponent method in entity class
* feat: add findByComponent method in entity and scene class
* feat: add findAllByComponent method in entity and scene class

### Bug Fixes

* fix: findByTag method issue in scene class

## 0.4.1

**EffectSDK Requirement**: 1010

### Bug Fixes

* fix: fix hook function bug in [Filter System](https://bytedance.feishu.cn/docs/doccnQ6aQiejx4jf8Jn5zlmMFWg)

## 0.4.0

**EffectSDK Requirement**: 1010

### Features

* feat: add MaterialFilter in [Filter System](https://bytedance.feishu.cn/docs/doccnQ6aQiejx4jf8Jn5zlmMFWg)
* feat: add Metal support to [Filter System](https://bytedance.feishu.cn/docs/doccnQ6aQiejx4jf8Jn5zlmMFWg)
* feat: add Metal support to Custom Assets and Segmentation

## 0.3.0

**EffectSDK Requirement**: 1010

### Features

* feat: add component property in Script class
* feat: make getComponent method to support scripting class class

## 0.2.0

**EffectSDK Requirement**: 1010

### Features

* feat: add custom component to support component scripting
* feat: add [Filter System](https://bytedance.feishu.cn/docs/doccnQ6aQiejx4jf8Jn5zlmMFWg)
* feat: add getComponent and getComponents methods in Entity class

### Bug Fixes

* fix: MISC entity and scene bugs
* fix(JS Asset): segmentation texture rendering issues

### Optimization

* perf: optimize algorithm wrapper peformance
