# Amazing JS

Amazing JS is the JS Wrapper for Amazing Engine

> It's built using [TSDX](https://tsdx.io/)

> If you’re new to TypeScript, checkout [this handy cheatsheet](https://devhints.io/typescript)

> For the most up to date & detailed development guide, check [AmazingJS](https://bytedance.us.feishu.cn/wiki/wikcn7esxLiFVdzraHwMtU019rc)
## Project Structure

* `dist` contains the compiled js library and should be ignored by git
* `doc-template` documentation template
* `docs` auto generated documentation
* `examples` folder contains the demos and sample projects
* `node_modules` dependent modules cache, ignored by git
* `specification` is the script that perform git commit format check
* `src` folder contains the source code of the JS Wrapper
* `tests` folder contains the unit tests
* `test-runner` contains sticker that can be loaded with AmazingEditor and run unit tests
* `types` folder contains the js API extracted from Amazing Engine

## Development

### 1.Create Demo

To develop new JS Wrapper API, you can start by creating a new sample project under `example/demo` folder

Make sure to include `amg.cjs.development.js` in your project, this file will automatically update when you edit the code in `src`

### 2. Start live update

Before we start coding it's a good idea to enable live update, this will runs the project in watch mode so any edits you save inside `src` causes a rebuild to `/dist` `dist/amg.cjs.development.js`

Developing for Amazing JS

```bash
npm run effect
```

[__DEPRECATED__]Use the following command if you're developing for Minigame platform


```bash
npm run start
```

### 3. Build Library

To do a release build, use `npm run build`

### 4. Run Test (WIP)

```bash
npm run effect
```

Open AmazingEditor, open `test-runner/effect-sticker-runner`. You'll see tests results inside log window.