import { FacePart } from '../../base/const';
import FaceData from './face-data';
/**
 * @class
 * @category Algorithm
 * @name FaceDataCat
 * @classdesc A FaceDataCat class stores head algorithm result including credibility score, transform, face index, yaw, pitch, roll, face rect and expression.
 * @description Constructor to create a new FaceDataCat instance.
 * @augments FaceData
 */
declare class FaceDataCat extends FaceData {
    constructor();
    /**
     * @function
     * @name FaceDataCat#getLandmarks
     * @returns {Vec2Vector} The 2d of the specific cat face.
     * @param {FacePart} facePart
     * @description Get the landmarks of the specific cat face.
     */
    getLandmarks(facePart: FacePart): any;
}
export { FaceDataCat };
