import { FacePart } from '../../base/const';
import FaceData from './face-data';
/**
 * @class
 * @category Algorithm
 * @name FaceDataDog
 * @classdesc A FaceDataDog class stores head algorithm result including credibility score, transform, face index, yaw, pitch, roll, face rect and expression.
 * @description Constructor to create a new FaceDataDog instance.
 * @augments FaceData
 */
declare class FaceDataDog extends FaceData {
    constructor();
    /**
     * @function
     * @name FaceDataDog#getLandmarks
     * @returns {Vec2Vector} The 2d of the specific dog face.
     * @param {FacePart} facePart
     * @description Get the landmarks of the specific dog face.
     */
    getLandmarks(facePart: FacePart): any;
}
export { FaceDataDog };
