import { FaceLandmarkType, FacePart } from '../../base/const';
import FaceData from './face-data';
/**
 * @class
 * @category Algorithm
 * @name FaceDataHuman
 * @classdesc A FaceDataHuman class stores head algorithm result including credibility score, transform, face index, yaw, pitch, roll, face rect and expression.
 * @description Constructor to create a new FaceDataHuman instance.
 * @augments FaceData
 */
declare class FaceDataHuman extends FaceData {
    constructor();
    /**
     * @function
     * @name FaceDataHuman#getLandmarks
     * @returns {Vec2Vector | Vec3Vector} The 2d or 3d landmarks of the specific face.
     * @param {FacePart} facePart
     * @param {FaceLandmarkType} faceLandmarkType If Face280 for facePart is not implemented, it will fall back to Face240, and so on. {@link amg.FaceLandmarkType}.
     * @description Get the landmarks of the specific face.
     */
    getLandmarks(facePart: FacePart, faceLandmarkType: FaceLandmarkType): any;
    private get106landmark;
    private get240landmark;
    private get280landmark;
}
export { FaceDataHuman };
