import Amaz = effect.Amaz;
/**
 * @enum {enum}
 * @memberof amg
 * @description Define the image's pixel formats.
 * @sdk 9.8.0
 */
import ImagePixelFormat = Amaz.PixelFormat;
/**
 * @memberof amg
 * @description Define the MSAA settings avaliable in render texture.
 * @sdk 9.8.0
 */
import MSAAMode = Amaz.MSAAMode;
/**
 * @memberof amg
 * @description Define the render texture attachment stencil/depth
 * @sdk 9.8.0
 */
import RenderTextureAttachment = Amaz.RenderTextureAttachment;
/**
 * @memberof amg
 * @description Define the mesh(sub-mesh) topology.
 * @sdk 9.8.0
 */
import Primitive = Amaz.Primitive;
/**
 * @memberof amg
 * @description Define wrap mode used by a texture uv
 * @sdk 9.8.0
 */
import TextureWrapMode = Amaz.WrapMode;
/**
 * @memberof amg
 * @description Define the texture's filter modes.
 * @property {number} NEAREST Uses the color of the texel closest to the pixel center for the pixel color..
 * @property {number} LINEAR Use nearest-neighbor sampling from individual mipmaps whilst linearly interpolating the two nearest mipmaps relevant to the sample.
 * @sdk 9.8.0
 */
import TextureFilterMode = Amaz.FilterMode;
/**
 * @memberof amg
 * @description Define the texture's mip mpa filter modes.
 * @sdk 9.8.0
 */
import TextureFilterMipMapMode = Amaz.FilterMipmapMode;
/**
 * @memberof amg
 * @description Shader Type.
 * @sdk 9.8.0
 */
import ShaderType = Amaz.ShaderType;
/**
 * @memberof amg
 * @description Render Type.
 * @sdk 9.8.0
 */
import RendererType = Amaz.RendererType;
/**
 * @memberof amg
 * @description Culling Settings
 * @sdk 9.8.0
 */
import CullFace = Amaz.CullFace;
/**
 * @memberof amg
 * @description Front Face Settings
 * @sdk 9.8.0
 */
import FrontFace = Amaz.FrontFace;
/**
 * @memberof amg
 * @description Polygon Type
 * @sdk 9.8.0
 */
import PolygonMode = Amaz.PolygonMode;
/**
 * @memberof amg
 * @description Compare Operation used by depth.
 * @sdk 9.8.0
 */
import CompareOp = Amaz.CompareOp;
/**
 * @memberof amg
 * @description Alpha blend factor.
 * @sdk 9.8.0
 */
import BlendFactor = Amaz.BlendFactor;
/**
 * @memberof amg
 * @description Operation used for blending.
 * @sdk 9.8.0
 */
import BlendOp = Amaz.BlendOp;
/**
 * @enum {enum}
 * @memberof amg
 * @description Define the device's orientation mode.
 * @property {number} Portrait Vertical screen.
 * @property {number} Landscape Horizontal screen.
 * @sdk 9.8.0
 */
declare enum DeviceOrientationMode {
    Portrait = 0,
    Landscape = 1
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define coordindate system for gyroscope data.
 * @property {number} Device Device bound coordindate system.
 * @property {number} Screen  Screen bound coordindate system.
 * @sdk 9.8.0
 */
/**
 * @enum {enum}
 * @memberof amg
 * @description Define the camera type.
 * @property {number} Perspective A camera with the perspective projection.
 * @property {number} Orthographic A camera with the orthographic projection.
 * @sdk 9.8.0
 */
declare enum CameraType {
    Perspective,
    Orthographic
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define the camera render events.
 * @property {number} AfterRender After camera render event.
 * @property {number} BeforeRender Before camera render event.
 * @property {number} AfterEverything After rendering everything.
 * @property {number} AfterImageEffects After rendering image effects.
 * @property {number} RenderImageEffects When rendering image effects.
 * @sdk 9.8.0
 */
declare enum CameraRenderEvent {
    AfterRender,
    BeforeRender,
    AfterEverything,
    AfterImageEffects,
    RenderImageEffects
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define vertex's attribute's types.
 * @property {number} Position Position attribute.
 * @property {number} Normal Normal attribute.
 * @property {number} Tangent Tangent attribute.
 * @property {number} Color Color attribute.
 * @property {number} Texcoord0 Texcoord0 attribute.
 * @sdk 9.8.0
 */
declare enum VertexAttribType {
    Position,
    Normal,
    Tangent,
    Color,
    Texcoord0
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define the light's type.
 * @property {number} Directional Directional light.
 * @property {number} Point Point light.
 * @property {number} Spot Spot light.
 * @sdk 9.8.0
 */
declare enum LightType {
    Directional = 0,
    Point = 1,
    Spot = 2
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define the 3d collider's types.
 * @property {number} Box 3d box collider.
 * @property {number} Sphere 3d sphere collider.
 * @property {number} Capsule 3d capsule collider.
 * @sdk 9.8.0
 */
declare enum Collider3DType {
    Box = 0,
    Sphere = 1,
    Capsule = 2
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define the 3d physics body's types.
 * @property {number} Static Static body.
 * @property {number} Kinematic Kinematic body, velocity based movement.
 * @property {number} Dynamic Dynamic body, force based movement.
 * @sdk 9.8.0
 */
declare enum Physics3DType {
    Static,
    Kinematic,
    Dynamic
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define 3d sprite's render mode.
 * @property {number} Fit Fit image's width/height to sprite size, keep aspect ratio.
 * @property {number} Fill Fill image's width/height to sprite size, keep aspect ratio.
 * @property {number} FitWidth Fit width only, keep aspect ratio..
 * @property {number} FitHeight Fit height only, keep aspect ratio..
 * @property {number} Stretch Stretch image to fit into sprite size.
 * @property {number} FillCut Fill image to sprite size, allow cut off.
 * @property {number} ImageSize Use image size.
 * @sdk 9.8.0
 */
declare enum SpriteRenderMode {
    Fit,
    Fill,
    FitWidth,
    FitHeight,
    Stretch,
    FillCut,
    ImageSize
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define the 2d sprite's render mode.
 * @property {number} Normal Use original image resource.
 * @property {number} Tiled The image will be repeated to fit the size of the sprite.
 * @property {number} Sliced The image is cut up into 9-slices.
 * @property {number} Filled Scale image to fill the size of the the sprite.
 * @property {number} Ellipse Render the sprite with ellipse mask.
 * @property {number} Free Freely adjust each corner of the sprite.
 * @property {number} Grid Arrange the image into grid.
 * @property {number} Corner Rounded corners.
 * @property {number} Outline Render image with outline.
 * @sdk 9.8.0
 */
declare enum ImageRenderMode {
    Normal,
    Tiled,
    Sliced,
    Filled,
    Ellipse,
    Free,
    Corner
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define the 2d sprite's fill type.
 * @property {number} Horizontal Fill image in horizontal direction.
 * @property {number} Vertical Fill image in vertical direction.
 * @property {number} Radial Fill image in radial direction.
 * @depends {@link amg.ImageRenderMode.Filled}
 * @sdk 9.8.0
 */
declare enum ImageFillType {
    Horizontal,
    Vertical,
    Radial
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define 2d layer's blending mode.
 * More info: https://en.wikipedia.org/wiki/Blend_modes
 * @property {number} Normal Default value, no color mixing.
 * @property {number} Add Each pixel's RGB component intensity is added to the intensity of the pixel values from the composition.
 * @property {number} Average Average blending.
 * @property {number} Burn This blend mode has the effect of making dark pixels darker while lighter pixels must be blended with other light colored pixels in order to remain bright.
 * @property {number} Dodge This can be thought of as the opposite of {@link amg.CanvasBlendMode.Burn}. Lighter pixels retain their brightness while darker pixels must be blended with other dark pixels in order to remain dark..
 * @property {number} Darken The darkest pixel of either the blend layer or the composition is used.
 * @property {number} Difference The layer pixel's intensity is subtracted from the composition pixel's intensity resulting in darker colors.
 * @property {number} Exclusion Exclusion is very similar to {@link amg.CanvasBlendMode.Difference}. Blending with white inverts the base color values, while blending with black produces no change. However, Blending with 50% gray produces 50% gray.
 * @property {number} Glow Glow effectively brightens the composition by the amount of brightness in the blend layer.  Black pixels in the blend layer are rendered as if they were transparent.
 * @property {number} HardLight Hard Light is also a combination of {@link amg.CanvasBlendMode.Multiply} and {@link amg.CanvasBlendMode.Screen}. {@link amg.CanvasBlendMode.HardLight} affects the blend layer's relationship to the base layer in the same way {@link amg.CanvasBlendMode.Overlay} affects the base layer's relationship to the blend layer. The inverse relationship between {@link amg.CanvasBlendMode.Overlay} and {@link amg.CanvasBlendMode.HardLight} makes them "commuted blend modes".
 * @property {number} HardMix It applies the blend by adding the value of each RGB channel into the blend layer to the corresponding RGB channel in the base layer.
 * @property {number} Lighten The lightest pixel of either the blend layer or the composition is used.
 * @property {number} LinearBurn Linear Burn decreases the brightness of the base color based on the value of the blend color.
 * @property {number} LinearDodge Linear Dodge produces similar but stronger results than {@link amg.CanvasBlendMode.Screen} or {@link amg.CanvasBlendMode.Dodge}.
 * @property {number} LinearLight Linear Light uses a combination of the {@link amg.CanvasBlendMode.LinearDodge} on lighter pixels and {@link amg.CanvasBlendMode.LinearBurn} on darker pixels.
 * @property {number} Multiply Each pixel's RGB component intensity is multiplied with the pixel value from the composition.
 * @property {number} Negation At first glance this seems similar to {@link amg.CanvasBlendMode.Difference}, however it actually produces the opposite effect.  Instead of making colors darker, it will make them brighter.
 * @property {number} Overlay This is a combination of {@link amg.CanvasBlendMode.Screen} and {@link amg.CanvasBlendMode.Multiply} modes.
 * @property {number} Phoenix This subtracts the lighter pixel from the darker pixel, and adds 255, giving a bright result.
 * @property {number} PinLight Pin Light is an extreme Blending Mode that performs a {@link amg.CanvasBlendMode.Darken} and {@link amg.CanvasBlendMode.Lighten} simultaneously. It can result in patches or blotches, and it completely removes all mid-tones.
 * @property {number} Reflect This blend mode can be used for adding shiny objects or areas of light. Black pixels in the blend layer are ignored as if they were transparent.
 * @property {number} Screen This can be thought of as the opposite of the {@link amg.CanvasBlendMode.Multiply} blend mode. It is used to make pixels brighter, with black being effectively transparent.
 * @property {number} Softlight Soft light is most closely related to {@link amg.CanvasBlendMode.Overlay} and is only similar to {@link amg.CanvasBlendMode.HardLight} by name. Applying pure black or white does not result in pure black or white.
 * @property {number} Substract The Subtract Blending Mode subtracts pixel values from the base layer. This Blending Mode drastically darkens pixels by subtracting brightness.
 * @property {number} VividLight You can think of Vivid Light as an extreme version of {@link amg.CanvasBlendMode.Overlay} and {@link amg.CanvasBlendMode.SoftLight}. Anything darker than 50% gray is darkened, and anything lighter than 50% gray is lightened.
 * @property {number} SnowColor Snow added blending.
 * @property {number} SnowHue Snow saturation blending.
 * @sdk 9.8.0
 */
declare enum CanvasBlendMode {
    Normal,
    Add,
    Average,
    Burn,
    Dodge,
    Darken,
    Difference,
    Exclusion,
    Glow,
    HardLight,
    HardMix,
    Lighten,
    LinearBurn,
    LinearDodge,
    LinearLight,
    Multiply,
    Negation,
    Overlay,
    Phoenix,
    PinLight,
    Reflect,
    Screen,
    Softlight,
    Substract,
    VividLight,
    SnowColor,
    SnowHue,
    EndFlag
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define 2d layer's mask types.
 * @property {number} None No mask.
 * @property {number} Rect Rectangle shape mask.
 * @property {number} Ellipse Ellipse shape mask.
 * @property {number} Sprites Sprite mask.
 * @sdk 9.8.0
 */
declare enum CanvasMaskType {
    None,
    Rect,
    Ellipse,
    Sprites
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define 2d layer's render order.
 * @property {number} Overlay Default, use predefined UI layer order.
 * @property {number} Custom Use order in scene, user can custom.
 * @sdk 9.8.0
 */
declare enum CanvasRenderOrder {
    Overlay,
    Custom
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define sequential image based animation's play mode.
 * @property {number} Once Play once.
 * @property {number} Loop Play then loop.
 * @property {number} PingPong Play then loop, forward then backward.
 * @property {number} Random Play random frame.
 * @sdk 9.8.0
 */
declare enum SeqAnimationPlayMode {
    Once,
    Loop,
    PingPong,
    Random
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define the canvas scaler's types.
 * @property {number} Origin Use 2d layer's.
 * @property {number} FitWidth Fit width, scale height but keep aspect ratio.
 * @property {number} FitHeight Fit height, scale width but keep aspect ratio.
 * @property {number} Fit Auto fit width or height depending on aspect ratio.
 * @property {number} Fill Scale both width and height to target 2d layer's size.
 * @sdk 9.8.0
 */
declare enum CanvasScalerType {
    Origin,
    FitWidth,
    FitHeight,
    Fit,
    Fill
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define the ui collider's tyoe.
 * @property {number} Box Box collider.
 * @sdk 9.8.0
 */
declare enum UIColliderType {
    Box = 0
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define the slider's mode.
 * @property {number} Follow Absolute value 0-1.
 * @property {number} Offset Offset value from 1st touch.
 * @property {number} DragThumb When dragging the slider's thumb.
 * @sdk 9.8.0
 */
declare enum SliderMode {
    Follow,
    Offset,
    DragThumb
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define the slider's moving direction.
 * @property {number} LeftRight Left to right.
 * @property {number} RightLeft Right to left.
 * @property {number} BottomTop Bottom to top.
 * @property {number} TopBottom Top to bottom.
 * @sdk 9.8.0
 */
declare enum UIMoveDirection {
    LeftRight,
    RightLeft,
    BottomTop,
    TopBottom
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define the label's font type.
 * @property {number} System System type.
 * @property {number} TrueType True type.
 * @property {number} Bitmap Bitmap type.
 * @sdk 9.8.0
 */
declare enum LabelFontType {
    System,
    TrueType,
    Bitmap
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define the label's alignment.
 * @property {number} Left Left alignment.
 * @property {number} Right Right alignment.
 * @property {number} Center Center alignment.
 * @sdk 9.8.0
 */
declare enum LabelAlignment {
    Left,
    Right,
    Center
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define the label's fit type.
 * @property {number} AutoSize Auto adjust size to fit to lable's bounding rect.
 * @property {number} FitWidth Adjust bounding rect 's width to fit its size.
 * @property {number} FitSize Fit label bounding rect's size to its size.
 * @sdk 9.8.0
 */
declare enum LabelFitType {
    AutoSize,
    FitWidth,
    FitSize
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define layout's types.
 * @property {number} None No layout.
 * @property {number} Horizontal Layout 2d components in horizontal direction.
 * @property {number} Vertical Layout 2d components in vertical direction.
 * @property {number} Grid Layout 2d components in grid.
 * @sdk 9.8.0
 */
declare enum LayoutType {
    None,
    Horizontal,
    Vertical,
    Grid
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define layout's size mode.
 * @property {number} None No layout.
 * @property {number} Container Resize container.
 * @property {number} Children Resize children.
 * @sdk 9.8.0
 */
declare enum LayoutSizeMode {
    None,
    Container,
    Children
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define layout's grid mode.
 * @property {number} Horizontal Horizontal first.
 * @property {number} Vertical Vertical first.
 * @sdk 9.8.0
 */
declare enum LayoutGridMode {
    Horizontal,
    Vertical
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define layout's vertical direction.
 * @property {number} TopBottom Top to bottom.
 * @property {number} BottomTop Bottom to top.
 * @depends amg.LayoutType
 * @sdk 9.8.0
 */
declare enum LayoutVerticalDirection {
    TopBottom,
    BottomTop
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define layout's horizontal direction.
 * @property {number} LeftRight Left to right.
 * @property {number} RightLeft Right to left.
 * @depends amg.LayoutType
 * @sdk 9.8.0
 */
declare enum LayoutHorizontalDirection {
    LeftRight,
    RightLeft
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define layout's sort mode.
 * @property {number} None No sorting.
 * @property {number} Alphabetic Alphabetic sorting.
 * @sdk 9.8.0
 */
declare enum LayoutSortMode {
    None,
    Alphabetic
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Different segmentation type.
 * @property {string} Head To get the head segmentation mask.
 * @property {string} Body To get the body segmentation mask.
 * @property {string} Hair To get the hair segmentation mask.
 * @property {string} Sky To get the sky segmentation mask.
 * @property {string} Building To get the building segmentation mask.
 * @property {string} Cloth To get the cloth segmentation mask.
 * @property {string} Ground To get the ground segmentation mask.
 * @property {string} Hand To get the hand segmentation mask.
 * @sdk 9.8.0
 */
declare enum SegmentationType {
    /**
     * @depends HeadSeg
     */
    Head = "head",
    /**
     * @depends BodySeg
     */
    Body = "body",
    /**
     * @depends Hair
     */
    Hair = "hair",
    /**
     * @depends SkySeg
     */
    Sky = "sky",
    /**
     * @depends BuildingSeg
     */
    Building = "building",
    /**
     * @depends Cloth
     */
    Cloth = "cloth",
    /**
     * @depends GroundSeg
     */
    Ground = "ground",
    /**
     * @depends HandSeg
     */
    Hand = "hand"
}
/**
 * @constant
 * @memberof amg
 * @name EntityLayerMax
 * @description Max layer: 64.
 * @type {number}
 */
declare const EntityLayerMax = 64;
/**
 * @constant
 * @memberof amg
 * @name EntityTagMax
 * @description Max tag 32.
 * @type {number}
 */
declare const EntityTagMax = 32;
/**
 * @enum {enum}
 * @memberof amg
 * @description Define play mode of animation.
 * @property {number} Once Play once then stop.
 * @property {number} Loop Play then loop.
 * @property {number} PingPong Play ping-pong loop.
 * @property {number} Clamp Play once then repeat last frame.
 * @property {number} Seek Seek to a frame then play it.
 * @sdk 9.8.0
 */
declare enum AnimationPlayMode {
    Once = 1,
    Loop = 0,
    PingPong = -1,
    Clamp = -2,
    Seek = -3
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define render orientation types of particle system.
 * @property {number} Billboard Always face camera.
 * @property {number} Direction Use moving direction for orientation.
 * @property {number} Shape Face camera by rotating around Up.
 * @property {number} Fixed No rotation applied.
 * @sdk 9.8.0
 */
declare enum ParticleSystemRenderOrientation {
    Billboard,
    Direction,
    Shape,
    Fixed
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define sorting modes of particle system.
 * @property {number} ByDistance By distance from camera, closer in front.
 * @property {number} OldestInFront By age, older in front.
 * @property {number} YoungestInFront By age, younger in front.
 */
declare enum ParticleSystemRenderSortingMode {
    ByDistance,
    OldestInFront,
    YoungestInFront
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define render types of particle system.
 * Use it for {@link amg.ParticleSystemRenderType.Mesh}.
 * @property {number} Quad Use quad mesh.
 * @property {number} Mesh Use custom mesh.
 */
declare enum ParticleSystemRenderType {
    Quad = 0,
    Mesh = 1
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define display modes of particle system.
 * Use it for {@link amg.ParticleSystemRenderType.Mesh}.
 * @property {number} ScaleByParticle Use particle's width/height/depth for scale.
 * @property {number} SizeByParticle  Use particle's width/height/depth and mesh's size (x,y,z) for scale.
 */
declare enum ParticleSystemRenderDisplayMode {
    ScaleByParticle,
    SizeByParticle
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define particle system's affector.
 * @property {number} None No affector.
 * @property {number} Color Add color affector.
 * @sdk 9.8.0
 */
declare enum ParticleSystemAffector {
    None = 0,
    Color = 1
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define oepration of particle system's color affecter.
 * @property {number} Set Set color.
 * @property {number} Multiply  Multiply color.
 * @property {number} Random Randomize color.
 */
declare enum ParticleSystemColorAffectorOperation {
    Set,
    Multiply,
    Random
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Face Type.
 * @property {number} Human
 * @property {number} Cat
 * @property {number} Dog
 * @sdk 9.8.0
 */
declare enum FaceType {
    Unknown = 0,
    Human = 1,
    Cat = 2,
    Dog = 3
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Face part.
 * @property {number} Whole
 * @property {number} LeftEye
 * @property {number} RightEye
 * @property {number} Nose
 * @property {number} Mouth
 * @property {number} LeftEyeBrow
 * @property {number} RightEyeBrow
 * @sdk 9.8.0
 */
declare enum FacePart {
    Whole = 0,
    LeftEye = 1,
    RightEye = 2,
    Nose = 3,
    Mouth = 4,
    LeftEyeBrow = 5,
    RightEyeBrow = 6,
    LeftEar = 7,
    RightEar = 8,
    Contour = 9
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Face expression. Remember it starts from -1.
 * @property {number} Unknown
 * @property {number} Angry
 * @property {number} Disgust
 * @property {number} Fear
 * @property {number} Happy
 * @property {number} Sad
 * @property {number} Surprise
 * @property {number} Neutral
 * @sdk 9.8.0
 */
declare enum FaceExpression {
    Unknown = 0,
    Angry = 1,
    Disgust = 2,
    Fear = 3,
    Happy = 4,
    Sad = 5,
    Surprise = 6,
    Neutral = 7
}
/**
 * @enum {enum}
 * @memberof amg
 * @description FaceEvent indicates head tracking status.
 * @property {string} Detected Head detected.
 * @property {string} Lost Lose track of a head.
 * @sdk 9.8.0
 */
declare enum FaceEvent {
    Detected = "detected",
    Lost = "lost"
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Face Action.
 * @property {number} None
 * @property {number} EyeBlink
 * @property {number} EyeBlinkLeft
 * @property {number} EyeBlinkRight
 * @property {number} MouthAh
 * @property {number} MouthPout
 * @property {number} HeadYaw
 * @property {number} HeadPitch
 * @property {number} BrowJump
 * @property {number} SideNod
 * @sdk 9.8.0
 */
declare enum FaceAction {
    None = 0,
    EyeBlink = 1,
    EyeBlinkLeft = 2,
    EyeBlinkRight = 3,
    MouthAh = 4,
    MouthPout = 5,
    HeadYaw = 6,
    HeadPitch = 7,
    BrowJump = 8,
    SideNod = 9
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Face Landmark type.
 * @property {number} Face106
 * @property {number} Face240
 * @property {number} Face280
 * @property {number} Face3d
 * @property {number} PetV2
 * @sdk 9.8.0
 */
declare enum FaceLandmarkType {
    Face106 = 0,
    Face240 = 1,
    Face280 = 2,
    Face3d = 3,
    PetV2 = 4
}
/**
 * @enum {enum}
 * @memberof amg
 * @description HandEvent indicates hand tracking status and gestures detected or changed.
 * @property {string} Detected Hand detected.
 * @property {string} Lost Lose track of a hand.
 * @property {string} StaticGesture Hand static gesture.
 * @property {string} DynamicGesture Hand dynamic gesture.
 * @sdk 9.8.0
 */
declare enum HandEvent {
    Lost = "lost",
    Detected = "detected",
    StaticGesture = "staticGesture",
    DynamicGesture = "dynamicGesture"
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Hand static gesture.
 * @property {number} HeartA
 * @property {number} HeartB
 * @property {number} HeartC
 * @property {number} HeartD
 * @property {number} OK
 * @property {number} HandOpen
 * @property {number} ThumbUp
 * @property {number} ThumbDown
 * @property {number} Rock
 * @property {number} Namaste
 * @property {number} PalmUp
 * @property {number} Fist
 * @property {number} IndexFingerUp
 * @property {number} DoubleFingerUp
 * @property {number} Victory
 * @property {number} BigV
 * @property {number} PhoneCall
 * @property {number} Beg
 * @property {number} Thanks
 * @property {number} Unknown
 * @property {number} Cabbage
 * @property {number} Three
 * @property {number} Four
 * @property {number} Pistol
 * @property {number} Rock2
 * @property {number} Swear
 * @property {number} HoldFace
 * @property {number} Salute
 * @property {number} Spread
 * @property {number} Pray
 * @property {number} QiGong
 * @property {number} Slide
 * @property {number} PalmDown
 * @property {number} Pistol2
 * @property {number} NinjaMudra1
 * @property {number} NinjaMudra2
 * @property {number} NinjaMudra3
 * @property {number} NinjaMudra4
 * @property {number} NinjaMudra5
 * @property {number} NinjaMudra6
 * @property {number} NinjaMudra7
 * @property {number} NinjaMudra8
 * @property {number} NinjaMudra9
 * @property {number} NinjaMudra10
 * @property {number} NinjaMudra11
 * @property {number} SpiderHand
 * @property {number} AvengerHand
 * @property {number} MaxCount
 * @property {number} Undetect
 * @property {number} None
 * @sdk 9.8.0
 */
declare enum HandStaticGesture {
    HeartA = 0,
    HeartB = 1,
    HeartC = 2,
    HeartD = 3,
    OK = 4,
    HandOpen = 5,
    ThumbUp = 6,
    ThumbDown = 7,
    Rock = 8,
    Namaste = 9,
    PalmUp = 10,
    Fist = 11,
    IndexFingerUp = 12,
    DoubleFingerUp = 13,
    Victory = 14,
    BigV = 15,
    PhoneCall = 16,
    Beg = 17,
    Thanks = 18,
    Unknown = 19,
    Cabbage = 20,
    Three = 21,
    Four = 22,
    Pistol = 23,
    Rock2 = 24,
    Swear = 25,
    HoldFace = 26,
    Salute = 27,
    Spread = 28,
    Pray = 29,
    QiGong = 30,
    Slide = 31,
    PalmDown = 32,
    Pistol2 = 33,
    NinjaMudra1 = 34,
    NinjaMudra2 = 35,
    NinjaMudra3 = 36,
    NinjaMudra4 = 37,
    NinjaMudra5 = 38,
    NinjaMudra6 = 39,
    NinjaMudra7 = 40,
    NinjaMudra8 = 41,
    NinjaMudra9 = 42,
    NinjaMudra10 = 43,
    NinjaMudra11 = 44,
    SpiderHand = 45,
    AvengerHand = 46,
    MaxCount = 47,
    Undetect = 48,
    None = 99
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Hand dynamic gesture.
 * @property {number} None Unknown or no dynamic gesture detected.
 * @property {number} Punching One punch to the camera.
 * @property {number} Clapping Clapping using two hands.
 * @property {number} HighFive High five with the camera.
 * @sdk 9.8.0
 */
declare enum HandDynamicGesture {
    None = 0,
    Punching = 1,
    Clapping = 2,
    HighFive = 4
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Key point of hand tracking algorithm result.
 * @property {number} Wrist
 * @property {number} Thumb3
 * @property {number} Thumb2
 * @property {number} Thumb1
 * @property {number} Thumb0
 * @property {number} Index3
 * @property {number} Index2
 * @property {number} Index1
 * @property {number} Index0
 * @property {number} Middle3
 * @property {number} Middle2
 * @property {number} Middle1
 * @property {number} Middle0
 * @property {number} Ring3
 * @property {number} Ring2
 * @property {number} Ring1
 * @property {number} Ring0
 * @property {number} Pinky3
 * @property {number} Pinky2
 * @property {number} Pinky1
 * @property {number} Pinky0
 * @property {number} Center
 * @sdk 9.8.0
 */
declare enum HandKeyPoint {
    Wrist = 0,
    Thumb3 = 1,
    Thumb2 = 2,
    Thumb1 = 3,
    Thumb0 = 4,
    Index3 = 5,
    Index2 = 6,
    Index1 = 7,
    Index0 = 8,
    Middle3 = 9,
    Middle2 = 10,
    Middle1 = 11,
    Middle0 = 12,
    Ring3 = 13,
    Ring2 = 14,
    Ring1 = 15,
    Ring0 = 16,
    Pinky3 = 17,
    Pinky2 = 18,
    Pinky1 = 19,
    Pinky0 = 20,
    Center = 21
}
/**
 * @enum {enum}
 * @memberof amg
 * @description BodyEvent indicates body tracking status.
 * @property {string} Detected Body detected.
 * @property {string} Lost Lose track of a body.
 * @property {string} Action Recognize an action of a body.
 * @sdk 9.8.0
 */
declare enum BodyEvent {
    Detected = "detected",
    Lost = "lost",
    Action = "action"
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Key point of skeleton2d algorithm result.
 * @property {number} Nose
 * @property {number} Neck
 * @property {number} RightShoulder
 * @property {number} RightElbow
 * @property {number} RightWrist
 * @property {number} LeftShoulder
 * @property {number} LeftElbow
 * @property {number} LeftWrist
 * @property {number} RightHip
 * @property {number} RightKnee
 * @property {number} RightAnkle
 * @property {number} LeftHip
 * @property {number} LeftKnee
 * @property {number} LeftAnkle
 * @property {number} RightEye
 * @property {number} LeftEye
 * @property {number} RightEar
 * @property {number} LeftEar
 * @sdk 9.8.0
 */
declare enum Body2DKeyPointType {
    Nose = 0,
    Neck = 1,
    RightShoulder = 2,
    RightElbow = 3,
    RightWrist = 4,
    LeftShoulder = 5,
    LeftElbow = 6,
    LeftWrist = 7,
    RightHip = 8,
    RightKnee = 9,
    RightAnkle = 10,
    LeftHip = 11,
    LeftKnee = 12,
    LeftAnkle = 13,
    RightEye = 14,
    LeftEye = 15,
    RightEar = 16,
    LeftEar = 17
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Key point of avatar3d algorithm result.
 * @property {number} Hips
 * @property {number} LeftUpLeg
 * @property {number} RightUpLeg
 * @property {number} Spine
 * @property {number} LeftLeg
 * @property {number} RightLeg
 * @property {number} Spine1
 * @property {number} LeftFoot
 * @property {number} RightFoot
 * @property {number} Spine2
 * @property {number} LeftToe
 * @property {number} RightToe
 * @property {number} Neck
 * @property {number} LeftShoulder
 * @property {number} RightShoulder
 * @property {number} Head
 * @property {number} LeftArm
 * @property {number} RightArm
 * @property {number} LeftForeArm
 * @property {number} RightForeArm
 * @property {number} LeftHand
 * @property {number} RightHand
 * @sdk 9.8.0
 */
declare enum Body3DKeyPointType {
    Hips = 0,
    LeftUpLeg = 1,
    RightUpLeg = 2,
    Spine = 3,
    LeftLeg = 4,
    RightLeg = 5,
    Spine1 = 6,
    LeftFoot = 7,
    RightFoot = 8,
    Spine2 = 9,
    LeftToe = 10,
    RightToe = 11,
    Neck = 12,
    LeftShoulder = 13,
    RightShoulder = 14,
    Head = 15,
    LeftArm = 16,
    RightArm = 17,
    LeftForeArm = 18,
    RightForeArm = 19,
    LeftHand = 20,
    RightHand = 21
}
/**
 * @enum {enum}
 * @memberof amg
 * @description AvatarDriveEvent indicates AvatarDrive face tracking status.
 * @property {string} Detected AvatarDrive face detected.
 * @property {string} Lost Lose track of a face.
 * @sdk 9.8.0
 */
declare enum AvatarDriveEvent {
    Detected = "detected",
    Lost = "lost"
}
/**
 * @enum {enum}
 * @memberof amg
 * @description AvatarDriveBlendShapeType indicates the factor of expression blending shapes, and the definition of blending shapes is the same as Apple ARkit, with 52 blending shapes. The enum value indicates the index of the type in the channels array.
 * @property {number} LeftEyeLookDown
 * @property {number} LeftNoseSneer
 * @property {number} LeftEyeLookIn
 * @property {number} BrowInnerUp
 * @property {number} LeftEyeSquint
 * @property {number} MouthClose
 * @property {number} RightMouthLowerDown
 * @property {number} JawOpen
 * @property {number} MouthShrugLower
 * @property {number} LeftMouthLowerDown
 * @property {number} MouthFunnel
 * @property {number} RightEyeLookIn
 * @property {number} RightEyeLookDown
 * @property {number} RightNoseSneer
 * @property {number} MouthRollUpper
 * @property {number} JawRight
 * @property {number} LeftMouthDimple
 * @property {number} MouthRollLower
 * @property {number} LeftMouthSmile
 * @property {number} LeftMouthPress
 * @property {number} RightMouthSmile
 * @property {number} RightMouthPress
 * @property {number} RightMouthDimple
 * @property {number} MouthLeft
 * @property {number} RightBrowDown
 * @property {number} LeftBrowDown
 * @property {number} LeftMouthFrown
 * @property {number} LeftEyeBlink
 * @property {number} LeftCheekSquint
 * @property {number} LeftBrowOuterUp
 * @property {number} LeftEyeLookUp
 * @property {number} JawLeft
 * @property {number} LeftMouthStretch
 * @property {number} RightMouthStretch
 * @property {number} MouthPucker
 * @property {number} RightEyeLookUp
 * @property {number} RightBrowOuterUp
 * @property {number} RightCheekSquint
 * @property {number} RightEyeBlink
 * @property {number} LeftMouthUpperUp
 * @property {number} RightMouthFrown
 * @property {number} RightEyeSquint
 * @property {number} JawForward
 * @property {number} RightMouthUpperUp
 * @property {number} CheekPuff
 * @property {number} LeftEyeLookOut
 * @property {number} RightEyeLookOut
 * @property {number} RightEyeWide
 * @property {number} MouthRight
 * @property {number} LeftEyeWide
 * @property {number} MouthShrugUpper
 * @property {number} TongueOut
 * @sdk 9.8.0
 */
declare enum AvatarDriveBlendShapeType {
    LeftEyeLookDown = 0,
    LeftNoseSneer = 1,
    LeftEyeLookIn = 2,
    BrowInnerUp = 3,
    LeftEyeSquint = 4,
    MouthClose = 5,
    RightMouthLowerDown = 6,
    JawOpen = 7,
    MouthShrugLower = 8,
    LeftMouthLowerDown = 9,
    MouthFunnel = 10,
    RightEyeLookIn = 11,
    RightEyeLookDown = 12,
    RightNoseSneer = 13,
    MouthRollUpper = 14,
    JawRight = 15,
    LeftMouthDimple = 16,
    MouthRollLower = 17,
    LeftMouthSmile = 18,
    LeftMouthPress = 19,
    RightMouthSmile = 20,
    RightMouthPress = 21,
    RightMouthDimple = 22,
    MouthLeft = 23,
    RightBrowDown = 24,
    LeftBrowDown = 25,
    LeftMouthFrown = 26,
    LeftEyeBlink = 27,
    LeftCheekSquint = 28,
    LeftBrowOuterUp = 29,
    LeftEyeLookUp = 30,
    JawLeft = 31,
    LeftMouthStretch = 32,
    RightMouthStretch = 33,
    MouthPucker = 34,
    RightEyeLookUp = 35,
    RightBrowOuterUp = 36,
    RightCheekSquint = 37,
    RightEyeBlink = 38,
    LeftMouthUpperUp = 39,
    RightMouthFrown = 40,
    RightEyeSquint = 41,
    JawForward = 42,
    RightMouthUpperUp = 43,
    CheekPuff = 44,
    LeftEyeLookOut = 45,
    RightEyeLookOut = 46,
    RightEyeWide = 47,
    MouthRight = 48,
    LeftEyeWide = 49,
    MouthShrugUpper = 50,
    TongueOut = 51
}
declare enum AssetType {
    Texture = "texture",
    Mesh = "mesh"
}
declare enum AssetSubType {
    Segmentation = "segmentation",
    Face = "face",
    CameraInput = "cameraInput",
    ImagePicker = "imagePicker"
}
/**
 * @enum {enum}
 * @memberof amg
 * @description State of GestureRecognizer.
 * @property {string} Possible The gesture is possilbe.
 * @property {string} Began The gesture is began.
 * @property {string} Changed The gesture is changed.
 * @property {string} Ended The gesture is ended.
 * @property {string} Cancelled The gesture is cancelled.
 * @property {string} Failed The gesture is failed.
 * @sdk 11.0.0
 */
declare enum GestureRecognizerState {
    Possible = "possible",
    Began = "began",
    Changed = "changed",
    Ended = "ended",
    Cancelled = "cancelled",
    Failed = "failed"
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Type of Gesture
 * @property {string} Tap Tap gesture.
 * @property {string} Pan Pan gesture.
 * @property {string} Pinch Pinch gesture.
 * @property {string} Rotation Rotation gesture.
 * @property {string} LongPress LongPress gesture.
 * @property {string} DoubleTap DoubleTap gesture.
 * @sdk 11.0.0
 */
declare enum GestureType {
    Tap = "tap",
    Pan = "pan",
    Pinch = "pinch",
    Rotation = "rotation",
    LongPress = "longPress",
    DoubleTap = "doubleTap"
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Type of ScreenRaycasterType
 * @property {number} UI The ScreenRaycaster for UI.
 * @property {number} AR The ScreenRaycaster for AR.
 * @property {number} ThreeD The ScreenRaycaster for ThreeD.
 * @property {number} TwoD The ScreenRaycaster for TwoD.
 * @property {number} Other The ScreenRaycaster for Other.
 * @sdk 11.0.0
 */
declare enum ScreenRaycasterType {
    AR = 0,
    UI = 1,
    ThreeD = 2,
    TwoD = 3,
    Other = 4
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Type of ScreenRespondType
 * @property {number} Began The ScreenRespond of Began.
 * @property {number} Ended The ScreenRespond of Ended.
 * @property {number} Respond The ScreenRespond of Respond.
 * @sdk 11.0.0
 */
declare enum ScreenRespondType {
    Began = "screenRespondBegan",
    Ended = "screenRespondEnded",
    Respond = "screenRespond"
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Type of TouchRespondType
 * @property {number} Once The Respond will be invoked once when touched.
 * @property {number} Continuous The Respond will be invoked continuous when touched.
 * @sdk 11.0.0
 */
declare enum TouchRespondType {
    Once = 0,
    Continuous = 1
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Different Audio Controller types.
 * @property {string} File Audio Controller Source will be a audio file.
 * @property {string} Mic Audio Controller Source will be from Mic Input.
 * @property {string} Music Audio Controller Source will be from internet Music Source.
 * @sdk 11.2.0
 */
declare enum AudioControllerType {
    File = "file",
    Mic = "mic",
    Music = "music"
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Different Audio File Controller States
 * @property {number} Preparing AudioFileController is Preparing the file.
 * @property {number} Playing AudioFileController is Playing the file.
 * @property {number} Stoping AudioFileController is Stopping the file.
 * @property {number} Stopped The file is stopped.
 * @property {number} Pausing AudioFileController is Pausing the file
 * @property {number} Paused The file is paused.
 * @property {number} Exception AudioFileController raised an Exception.
 * @sdk 11.2.0
 */
declare enum AudioFileControllerState {
    Preparing = 0,
    Playing = 1,
    Stoping = 2,
    Stopped = 3,
    Pausing = 4,
    Paused = 5,
    Exception = -1
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Different Audio Effect types.
 * @property {string} Reverb Reverb audio effect.
 * @property {string} Megaphone Megaphone audio effect.
 * @property {string} Compressor Compressor audio effect.
 * @property {string} Delay Delay audio effect.
 * @property {string} Filter Filter audio effect.
 * @property {string} Vibrato Vibrato audio effect.
 * @property {string} Limiter Limiter audio effect.
 * @sdk 11.2.0
 */
declare enum AudioEffectType {
    Reverb = "reverb",
    Megaphone = "megaphone",
    Compressor = "compressor",
    Delay = "delay",
    Filter = "filter",
    Vibrato = "vibrato",
    Limiter = "limiter"
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Define the Audio Effect Filter Type
 * @property {number} LowPass Low Pass Filter.
 * @property {number} HighPass High Pass Filter.
 * @sdk 11.2.0
 */
declare enum AudioEffectFilterType {
    LowPass = 0,
    HighPass = 1
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Different Audio Extractor types.
 * @property {string} EnergyDetection Energy extractor.
 * @property {string} PitchDetection Pitch extractor.
 * @property {string} BeatsDetection Beats extractor.
 * @property {string} VolumeDetection Volume extractor.
 * @property {string} OnsetDetection Onset extractor.
 * @sdk 11.2.0
 */
declare enum AudioExtractorType {
    Energy = "energyDetection",
    PitchDetection = "pitchDetection",
    BeatsDetection = "beatsDetection",
    VolumeDetection = "volumeDetection",
    OnsetDetection = "onsetDetection"
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Different Audio Events.
 * @property {string} Play AudioController is playing audio.
 * @property {string} Pause AudioController paused the audio.
 * @property {string} Resume AudioController is resuming the audio.
 * @property {string} Stop AudioController is stopping the audio.
 * @property {string} LoopCompletion AudioFileController completed 1 full loop of the file.
 * @sdk 11.2.0
 */
declare enum AudioEvent {
    Play = "play",
    Pause = "pause",
    Resume = "resume",
    Stop = "stop",
    LoopCompletion = "loopCompletion"
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Different Bytenn forward type.
 * @property {number} CPU CPU
 * @property {number} GPU GPU
 * @property {number} DSP DSP
 * @property {number} NPU NPU
 * @property {number} AUTO AUTO
 * @property {number} METAL METAL
 * @property {number} OPENCL OPENCL
 * @property {number} OPENGL OPENGL
 * @property {number} VULKAN VALKAN
 * @property {number} CUDA CUDA
 * @property {number} CoreML CoreML
 * @sdk 11.2.0
 */
declare enum ByteNNForwardType {
    CPU = 0,
    GPU = 1,
    DSP = 2,
    NPU = 3,
    AUTO = 4,
    METAL = 5,
    OPENCL = 6,
    OPENGL = 7,
    VULKAN = 8,
    CUDA = 9,
    CoreML = 10
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Different Bytenn data type
 * @property {number} U8 Unsigned short
 * @property {number} Int8 Signed short
 * @property {number} Int16 Signed int
 * @property {number} Uint16 Unsigned int
 * @property {number} Float Float
 * @property {number} FP16 FP16
 * @property {number} Double Double
 * @sdk 11.2.0
 */
declare enum ByteNNDataType {
    U8 = 0,
    Int8 = 1,
    Int16 = 2,
    Uint16 = 3,
    Float = 4,
    Fp16 = 5,
    Double = 6
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Different color conversion code
 * @property {number} COLOR_BGR2BGRA
 * @property {number} COLOR_RGB2RGBA
 * @property {number} COLOR_BGRA2BGR
 * @property {number} COLOR_RGBA2RGB
 * @property {number} COLOR_BGR2RGBA
 * @property {number} COLOR_RGB2BGRA
 * @property {number} COLOR_RGBA2BGR
 * @property {number} COLOR_BGRA2RGB
 * @property {number} COLOR_BGR2RGB
 * @property {number} COLOR_RGB2BGR
 * @property {number} COLOR_BGRA2RGBA
 * @property {number} COLOR_RGBA2BGRA
 * @property {number} COLOR_BGR2GRAY
 * @property {number} COLOR_RGB2GRAY
 * @property {number} COLOR_GRAY2BGR
 * @property {number} COLOR_GRAY2RGB
 * @property {number} COLOR_GRAY2BGRA
 * @property {number} COLOR_GRAY2RGBA
 * @property {number} COLOR_BGRA2GRAY
 * @property {number} COLOR_RGBA2GRAY
 * @sdk 11.2.0
 */
declare enum ColorConversionCodes {
    COLOR_BGR2BGRA = 0,
    COLOR_RGB2RGBA = 0,
    COLOR_BGRA2BGR = 1,
    COLOR_RGBA2RGB = 1,
    COLOR_BGR2RGBA = 2,
    COLOR_RGB2BGRA = 2,
    COLOR_RGBA2BGR = 3,
    COLOR_BGRA2RGB = 3,
    COLOR_BGR2RGB = 4,
    COLOR_RGB2BGR = 4,
    COLOR_BGRA2RGBA = 5,
    COLOR_RGBA2BGRA = 5,
    COLOR_BGR2GRAY = 6,
    COLOR_RGB2GRAY = 7,
    COLOR_GRAY2BGR = 8,
    COLOR_GRAY2RGB = 8,
    COLOR_GRAY2BGRA = 9,
    COLOR_GRAY2RGBA = 9,
    COLOR_BGRA2GRAY = 10,
    COLOR_RGBA2GRAY = 11
}
/**
 * @enum {enum}
 * @memberof amg
 * @description Different cv matrix format
 * @property {number} CV_16S
 * @property {number} CV_16SC1
 * @property {number} CV_16SC2
 * @property {number} CV_16SC3
 * @property {number} CV_16SC4
 * @property {number} CV_16U
 * @property {number} CV_16UC1
 * @property {number} CV_16UC2
 * @property {number} CV_16UC3
 * @property {number} CV_16UC4
 * @property {number} CV_32F
 * @property {number} CV_32FC1
 * @property {number} CV_32FC2
 * @property {number} CV_32FC3
 * @property {number} CV_32FC4
 * @property {number} CV_32S
 * @property {number} CV_32SC1
 * @property {number} CV_32SC2
 * @property {number} CV_32SC3
 * @property {number} CV_32SC4
 * @property {number} CV_64F
 * @property {number} CV_64FC1
 * @property {number} CV_64FC2
 * @property {number} CV_64FC3
 * @property {number} CV_64FC4
 * @property {number} CV_8S
 * @property {number} CV_8S1
 * @property {number} CV_8S2
 * @property {number} CV_8S3
 * @property {number} CV_8S4
 * @property {number} CV_8U
 * @property {number} CV_8U1
 * @property {number} CV_8U2
 * @property {number} CV_8U3
 * @property {number} CV_8U4
 */
declare enum CVMatrixFormat {
    CV_16S = 3,
    CV_16SC1 = 3,
    CV_16SC2 = 11,
    CV_16SC3 = 19,
    CV_16SC4 = 27,
    CV_16U = 2,
    CV_16UC1 = 2,
    CV_16UC2 = 10,
    CV_16UC3 = 18,
    CV_16UC4 = 26,
    CV_32F = 5,
    CV_32FC1 = 5,
    CV_32FC2 = 13,
    CV_32FC3 = 21,
    CV_32FC4 = 29,
    CV_32S = 4,
    CV_32SC1 = 4,
    CV_32SC2 = 12,
    CV_32SC3 = 20,
    CV_32SC4 = 28,
    CV_64F = 6,
    CV_64FC1 = 6,
    CV_64FC2 = 14,
    CV_64FC3 = 22,
    CV_64FC4 = 30,
    CV_8S = 1,
    CV_8SC1 = 1,
    CV_8SC2 = 9,
    CV_8SC3 = 17,
    CV_8SC4 = 25,
    CV_8U = 0,
    CV_8UC1 = 0,
    CV_8UC2 = 8,
    CV_8UC3 = 16,
    CV_8UC4 = 24
}
export { CameraType, VertexAttribType, LightType, Collider3DType, Physics3DType, SpriteRenderMode, ImageRenderMode, ImageFillType, CanvasBlendMode, CanvasMaskType, CanvasRenderOrder, SeqAnimationPlayMode, CanvasScalerType, UIColliderType, SliderMode, UIMoveDirection, LabelFontType, LabelAlignment, LabelFitType, LayoutType, LayoutSizeMode, LayoutGridMode, LayoutVerticalDirection, LayoutHorizontalDirection, LayoutSortMode, SegmentationType, EntityLayerMax, EntityTagMax, AnimationPlayMode, ParticleSystemRenderOrientation, ParticleSystemRenderSortingMode, ParticleSystemRenderType, ParticleSystemRenderDisplayMode, ParticleSystemAffector, ParticleSystemColorAffectorOperation, FaceType, FacePart, FaceExpression, FaceEvent, FaceAction, FaceLandmarkType, HandEvent, HandStaticGesture, HandDynamicGesture, HandKeyPoint, BodyEvent, Body2DKeyPointType, Body3DKeyPointType, AvatarDriveEvent, AvatarDriveBlendShapeType, AssetType, AssetSubType, DeviceOrientationMode, GestureRecognizerState, GestureType, ScreenRaycasterType, TouchRespondType, ScreenRespondType, CameraRenderEvent, ImagePixelFormat, MSAAMode, RenderTextureAttachment, Primitive, TextureWrapMode, TextureFilterMode, TextureFilterMipMapMode, ShaderType, RendererType, CullFace, FrontFace, PolygonMode, CompareOp, BlendFactor, BlendOp, AudioControllerType, AudioFileControllerState, AudioEffectType, AudioEffectFilterType, AudioExtractorType, AudioEvent, ByteNNForwardType, ByteNNDataType, ColorConversionCodes, CVMatrixFormat, };
