import Mesh, { MeshData } from './mesh';
export default class GeometryUtil {
    private static getPlaneData;
    static createPlane(udir: number, vdir: number, width: number, height: number, depth: number, gridX: number, gridY: number): Mesh;
    static createBoxMesh(width: number, height: number, depth: number, calculateTangents?: boolean): Mesh;
    static getSphereData(radius: number, part?: 'full' | 'top' | 'bottom', widthSegments?: number, heightSegments?: number, heightOffset?: number, calculateTangents?: boolean): MeshData;
    static createSphereMesh(radius: number, widthSegments?: number, heightSegments?: number, heightOffset?: number): Mesh;
    static getCircleData(radius: number, segments?: number, heightOffset?: number, calculateTangents?: boolean): MeshData;
    static getConeData(height: number, bottomRadius: number, topRadius: number, heightSegments?: number, capSegments?: number, cacluateTangents?: boolean): MeshData;
    static createCylinderMesh(radius: number, height: number, heightSegments?: number, capSegments?: number): Mesh;
    static createCapsule(radius: number, height: number, heightSegments?: number, capSegments?: number): Mesh;
    static createToursMesh(tubeRadius: number, ringRadius: number, ringSegments?: number, tubeSegments?: number): Mesh;
}
