import { EventHandler, SceneObject } from '..';
/**
 * @class
 * @category Core
 * @name Prefab
 * @classdesc Prefab class for prefab object.
 * @hideconstructor
 * @sdk 9.8.0
 */
export default class Prefab extends EventHandler {
    private _native;
    constructor(native: effect.Amaz.Prefab);
    /**
     * @function
     * @name Prefab#instantiate
     * @description Create prefab instance from prefab and add it into default scene or a scene object.
     * @param {boolean} shouldUnpack - Should unpack the prefab instance or keep links to the original objects in prefab.
     * @param {SceneObject} rootSceneObject - Tartget scene object, default to scene if no scene object provided.
     * @returns {SceneObject} - Return the root scene object of the prefab instance.
     * @sdk 9.8.0
     */
    instantiate(shouldUnpack: boolean, rootSceneObject?: SceneObject): SceneObject | undefined;
    /**
     * @name Prefab#root
     * @type {SceneObject}
     * @description Root scene object of the prefab.
     * @readonly
     * @sdk 9.8.0
     */
    get root(): SceneObject | undefined;
}
