/**
 * @class
 * @category Rendering
 * @name Renderer
 * @classdesc A class for rendering to device.
 * @hideconstructor
 * @sdk 9.8.0
 */
export default class Renderer {
    private _gl;
    private _ext;
    private _program;
    private _vao;
    private _vertexBuffer;
    private _uvBuffer;
    private _attPosition;
    private _attUV;
    private _uniInputTexture;
    constructor(gl: WebGLRenderingContext);
    /**
     * @function
     * @name Renderer#render
     * @description Render to target.
     * @param {WebGLTexture} texture - Target texture.
     * @param {number} width - Width.
     * @param {number} height - Height.
     * @sdk 9.8.0
     */
    render(texture: WebGLTexture, width: number, height: number): void;
    private buildShader;
    private buildProgram;
    destroy(): void;
}
