import { SceneObject, ScreenRaycasterType } from '..';
import ScreenRaycasterComponent from '../component/screen-raycaster-component';
/**
 * @class
 * @category Gesture
 * @name ScreenHitInfo
 * @classdesc Class for ScreenHitInfo.
 * @description Constructor to create a ScreenHitInfo.
 * @sdk 11.0.0
 */
export default class ScreenHitInfo {
    private _type;
    private _caster;
    private _sceneObjects;
    constructor(type: ScreenRaycasterType, caster: ScreenRaycasterComponent, sceneObjects: Array<SceneObject>);
    /**
     * @name ScreenHitInfo#type
     * @type {ScreenRaycasterType}
     * @description The type of the HitInfo.
     * @sdk 11.0.0
     */
    get type(): ScreenRaycasterType;
    /**
     * @name ScreenHitInfo#caster
     * @type {ScreenRaycasterType}
     * @description The ScreenRaycasterComponent which emit the HitInfo.
     * @sdk 11.0.0
     */
    get caster(): ScreenRaycasterComponent;
    /**
     * @name ScreenHitInfo#sceneObjects
     * @type {Array<SceneObject>}
     * @description The hit sceneObjects which are sorted from near to far.
     * @sdk 11.0.0
     */
    get sceneObjects(): Array<SceneObject>;
}
