import Texture from '../base/texture';
import { WrapMode, FilterMode } from '../base/texture';
import Amaz = effect.Amaz;
/**
 * @class
 * @category Rendering
 * @name Texture2D
 * @classdesc Class for rendering texture.
 * @description Constructor to create a Texture instance.
 * @sdk 9.8.0
 */
export default class Texture2D extends Texture {
    constructor(native: Amaz.Texture2D | undefined, width: number, height: number, depth: number, image?: Amaz.Image | undefined, wrapMode?: WrapMode | undefined, filterMode?: FilterMode | undefined);
    native: Amaz.Texture2D;
    private _image;
    get image(): Amaz.Image;
    set image(image: Amaz.Image);
    private _isColorTexture;
    get isColorTexture(): boolean;
    set isColorTexture(isColor: boolean);
    /**
     * @param {Amaz.Image} image image class to be loaded into the texture
     * @function
     * @name Texture2D#setImageOnTexture
     * @description Load image onto a 2d texture
     * @returns {void}
     * @sdk 9.8.0
     */
    setImageOnTexture(image: Amaz.Image): void;
}
