import { ScreenRaycasterType, Vec2 } from '..';
import Amaz = effect.Amaz;
import EventHandler from './event-handler';
import { TouchRespondType } from './const';
/**
 * @class
 * @category Gesture
 * @name TouchRespond
 * @augments EventHandler
 * @classdesc TouchRespond class for fire raycaster hit event.
 * @description Constructor to create a TouchRespond instance.
 */
export default class TouchRespond extends EventHandler {
    private _raycasterComps;
    private _respondOrder;
    private _curTouchNum;
    private _touched;
    private _fireEndedDirty;
    private _respondType;
    /**
     * @name TouchRespond#type
     * @type {TouchRespondType}
     * @description The type of raycaster.
     * @sdk 11.0.0
     */
    get type(): TouchRespondType;
    set type(type: TouchRespondType);
    /**
     * @name TouchRespond#order
     * @type {Array<ScreenRaycasterType>}
     * @description The order to do raycast, the default order is [UI, TwoD, ThreeD, Other, AR].
     * @sdk 11.0.0
     */
    get order(): Array<ScreenRaycasterType>;
    set order(order: Array<ScreenRaycasterType>);
    start(): void;
    destroy(): void;
    update(_deltaTime: number): void;
    _fireRespondEvent(touchPos: Vec2): void;
    onEvent(event: Amaz.Event): void;
}
