import Mat4 from '../math/mat4';
import Amaz = effect.Amaz;
export declare class MeshUtil {
    /**
     * @ignore
     */
    static createQuadMesh(): Amaz.Mesh;
}
export declare class StringUtil {
    static toPascalCase(str: string): string;
    static getFilename(uri: string): string;
}
export declare class RenderingUtil {
    /**
     * @param shaders
     * @param renderState
     * @ignore
     */
    static createShaderPass(shaders: any, renderState: any): Amaz.Pass;
    /**
     * @param shaders
     * @ignore
     */
    static createScreenMaterial(shaders: any): Amaz.Material;
    /**
     * @param pass
     * @ignore
     */
    static createMaterial(pass: any): Amaz.Material;
    /**
     * @ignore
     */
    static createRenderTexture(): Amaz.RenderTexture;
    /**
     * @param width
     * @param height
     * @param colorFormat
     * @param filterMode
     * @ignore
     */
    static createRenderTexturePlus(width: number, height: number, colorFormat: Amaz.PixelFormat, filterMode: Amaz.FilterMode): Amaz.RenderTexture;
    /**
     * @ignore
     */
    static createTexture2D(): Amaz.Texture2D;
    /**
     * @param shaders
     * @ignore
     */
    static createShaders(shaders: any): Amaz.Map;
    static createEmptyMaterial(): Amaz.Material;
    static addPassToMaterial(material: Amaz.Material, shaders: any, stencilMasked: boolean, blending?: boolean): Amaz.Pass;
}
export declare class CmdBufferHelper {
    private _screenMesh;
    private _cmdBuffer;
    private _cmdBufferDirty;
    constructor();
    onPreUpdate(): void;
    onPostUpdate(): void;
    get screenMesh(): Amaz.Mesh;
    cmdBufferSetRenderTexture(target: Amaz.RenderTexture): void;
    cmdBufferClearRenderTexture(clearColor: boolean, clearDepth: boolean, backgroundColor: Amaz.Color, depth: number): void;
    cmdBufferDrawMesh(mesh: Amaz.Mesh, matrix: Mat4, material: Amaz.Material, submeshIndex: number, shaderPass: number, properties: Amaz.MaterialPropertyBlock): void;
    cmdBufferBlit(src: Amaz.Texture, dst: Amaz.RenderTexture): void;
}
export declare class VersionHelper {
    static doesSDKSupport(requiredVersion: string): boolean;
}
