import Component from './component';
import SceneObject from '../scene/scene-object';
interface UIInteractOptions {
    touchEnabled?: boolean;
}
/**
 * @class
 * @category Component
 * @name UIInteractComponent
 * @augments Component
 * @classdesc Abstract UIInteractComponent class for UI Interaction.
 * @hideconstructor
 * @sdk 9.8.0
 */
declare abstract class UIInteractComponent extends Component {
    constructor(sceneObject?: SceneObject, nativeClass?: string, options?: UIInteractOptions);
    protected getProps(): Array<string>;
    /**
     *
     */
    get touchEnabled(): boolean;
    /**
     *
     */
    set touchEnabled(value: boolean);
}
export { UIInteractOptions, UIInteractComponent };
