import Component from './component';
import SceneObject from '../scene/scene-object';
interface WidgetOptions {
    alpha?: number;
    alphaCascading?: boolean;
}
/**
 * @class
 * @category Component
 * @name WidgetComponent
 * @augments Component
 * @classdesc Abstract WidgetComponent class for 2d widgets.
 * @hideconstructor
 * @sdk 9.8.0
 */
declare abstract class WidgetComponent extends Component {
    constructor(sceneObject?: SceneObject, nativeClass?: string, options?: WidgetOptions);
    protected getProps(): Array<string>;
    /**
     * @name WidgetComponent#alpha
     * @type {number}
     * @description The widget's alpha.
     * @sdk 9.8.0
     */
    get alpha(): number;
    set alpha(value: number);
    /**
     * @name WidgetComponent#alphaCascading
     * @type {boolean}
     * @description The widget's alpha cascading flag.
     * @sdk 9.8.0
     */
    get alphaCascading(): boolean;
    set alphaCascading(value: boolean);
}
export { WidgetOptions, WidgetComponent };
