import Amaz = effect.Amaz;
import GestureRecognizer from './base-recognizer';
import TouchGesture from '../touch-gesture';
import { Vec2 } from '../../..';
/**
 * @class
 * @category Gesture
 * @name DoubleTapGestureRecognizer
 * @augments GestureRecognizer
 * @classdesc The DoubleTapGestureRecognizer class is used to recognize the double-tap gesture.
 * @description Constructor to create an DoubleTapGestureRecognizer instance.
 * @param {TouchGesture} touchGesture - The touchGesture instance.
 */
export default class DoubleTapGestureRecognizer extends GestureRecognizer {
    private _maxDuration;
    private _maxDeltaMovement;
    private _maxInterval;
    private _tp1Pos;
    private _tp1Time;
    private _tp1leaveTime;
    private _touchPos;
    private _firstReady;
    private _curTime;
    constructor(touchGesture: TouchGesture);
    /**
     * @name DoubleTapGestureRecognizer#position
     * @type {Vec2}
     * @description The touched position.
     * @readonly
     */
    get position(): Vec2;
    reset(): void;
    update(_deltaTime: number): void;
    handleTouch(touch: Amaz.TouchPointer): void;
}
