import Amaz = effect.Amaz;
import GestureRecognizer from './base-recognizer';
import TouchGesture from '../touch-gesture';
import { Vec2 } from '../../..';
/**
 * @class
 * @category Gesture
 * @name LongPressGestureRecognizer
 * @augments GestureRecognizer
 * @classdesc The LongPressGestureRecognizer class is used to recognize the long-press gesture.
 * @description Constructor to create an LongPressGestureRecognizer instance.
 * @param {TouchGesture} touchGesture - The touchGesture instance.
 */
export default class LongPressGestureRecognizer extends GestureRecognizer {
    private _minDuration;
    private _maxDeltaMovement;
    private _tp1Pos;
    private _tp1Time;
    private _touchPos;
    constructor(touchGesture: TouchGesture);
    /**
     * @name LongPressGestureRecognizer#position
     * @type {Vec2}
     * @description The touched position.
     * @readonly
     */
    get position(): Vec2;
    reset(): void;
    handleTouch(touch: Amaz.TouchPointer): void;
}
