import Amaz = effect.Amaz;
import GestureRecognizer from './base-recognizer';
import TouchGesture from '../touch-gesture';
import { Vec2 } from '../../..';
/**
 * @class
 * @category Gesture
 * @name PanGestureRecognizer
 * @augments GestureRecognizer
 * @classdesc The PanGestureRecognizer class is used to recognize the pan gesture.
 * @description Constructor to create an PanGestureRecognizer instance.
 * @param {TouchGesture} touchGesture - The touchGesture instance.
 */
export default class PanGestureRecognizer extends GestureRecognizer {
    private _initPos;
    private _curPos;
    constructor(touchGesture: TouchGesture);
    /**
     * @name PanGestureRecognizer#initPosition
     * @type {Vec2}
     * @description The first touch position.
     * @readonly
     */
    get initPosition(): Vec2;
    /**
     * @name PanGestureRecognizer#currentPosition
     * @type {Vec2}
     * @description The current touch position.
     * @readonly
     */
    get currentPosition(): Vec2;
    /**
     * @name PanGestureRecognizer#offset
     * @type {Vec2}
     * @description The offset vector2, from initPos to curPos.
     * @readonly
     */
    get offset(): Vec2;
    reset(): void;
    handleTouch(touch: Amaz.TouchPointer): void;
}
