import Amaz = effect.Amaz;
import GestureRecognizer from './base-recognizer';
import TouchGesture from '../touch-gesture';
/**
 * @class
 * @category Gesture
 * @name PinchGestureRecognizer
 * @augments GestureRecognizer
 * @classdesc The PinchGestureRecognizer class is used to recognize the pan gesture.
 * @description Constructor to create an PinchGestureRecognizer instance.
 * @param {TouchGesture} touchGesture - The touchGesture instance.
 */
export default class PinchGestureRecognizer extends GestureRecognizer {
    private _tp1Id;
    private _tp1Pos;
    private _tp2Id;
    private _tp2Pos;
    private _scale;
    private _deltaScale;
    private _initDis;
    private _lastScale;
    constructor(touchGesture: TouchGesture);
    /**
     * @name PinchGestureRecognizer#scale
     * @type {number}
     * @description The ratio of the distance of the first two fingers to the distance of the
     * current two fingers.
     * @readonly
     */
    get scale(): number;
    /**
     * @name PinchGestureRecognizer#delta
     * @type {number}
     * @description The delta scale between last and current scales.
     * @readonly
     */
    get delta(): number;
    reset(): void;
    handleTouch(touch: Amaz.TouchPointer): void;
}
