import Amaz = effect.Amaz;
import GestureRecognizer from './base-recognizer';
import TouchGesture from '../touch-gesture';
/**
 * @class
 * @category Gesture
 * @name RotationGestureRecognizer
 * @augments GestureRecognizer
 * @classdesc The RotationGestureRecognizer class is used to recognize the pan gesture.
 * @description Constructor to create an RotationGestureRecognizer instance.
 * @param {TouchGesture} touchGesture - The touchGesture instance.
 */
export default class RotationGestureRecognizer extends GestureRecognizer {
    private _tp1Id;
    private _tp1Pos;
    private _tp2Id;
    private _tp2Pos;
    private _initDir;
    private _lastYaw;
    private _deltaYaw;
    private _yaw;
    constructor(touchGesture: TouchGesture);
    reset(): void;
    /**
     * @name RotationGestureRecognizer#rotation
     * @type {number}
     * @description The total rotation radian (unit radian).
     * @readonly
     */
    get rotation(): number;
    /**
     * @name RotationGestureRecognizer#delta
     * @type {number}
     * @description The delta radian (unit radian).
     * @readonly
     */
    get delta(): number;
    handleTouch(touch: Amaz.TouchPointer): void;
}
