import Amaz = effect.Amaz;
export interface Plugin {
    onStart(): void;
    onUpdate(deltaTime: number): void;
    onLateUpdate(deltaTime: number): void;
    onDestroy(): void;
    onEvent(event: Amaz.Event): void;
}
declare type PluginMap = {
    [key: string]: any;
};
export default class PluginRegistry {
    private _plugins;
    constructor();
    bufferToStr(buf: ArrayBuffer): string;
    start(): void;
    loadPlugins(): void;
    initPlugin(config: any, name: string): object | null;
    update(deltaTime: number): void;
    lateUpdate(deltaTime: number): void;
    destroy(): void;
    event(event: Amaz.Event): void;
    get plugins(): PluginMap;
}
export {};
