import { EventHandler } from '../..';
import Prefab from '../../base/prefab';
/**
 * @class
 * @category Core
 * @name PrefabRegistry
 * @classdesc Class to manage prefabs.
 * @example
 * // use prefabRegistry to load a {@link Prefab}
 * amg.Engine.prefabs.load('prefabs/Cube.prefab');
 * @hideconstructor
 * @sdk 9.8.0
 */
export default class PrefabRegistry extends EventHandler {
    private prefabManager;
    constructor();
    /**
     * @function
     * @name PrefabRegistry#load
     * @returns {Prefab} Loaded prefab object.
     * @description Load a prefab from the specified path.
     * @param {string} path The path for the prefab.
     * @example
     * // load a prefab {@link Prefab}
     * amg.Engine.prefabs.load('prefabs/Cube.prefab');
     * @sdk 9.8.0
     */
    load(path: string): Prefab | undefined;
}
