# Type Definitions for Amazing JS Binding API
## Description

This tool utlizes the script to generate RTTI.JSON which holds all the classes that has been build in the effect_sdk. The calsses are obtained from the RTTIManager which includes all the classes that has been difened with RTTI define macros. The program script/build_rtti_gen.sh will build the c++ program that will generate the /Users/bytedance/effect_sdk/build/effect_sdk/dev/rtti/RTTI_JSON.json

Use @babel/parser to generate the AST syntax tree from the d.ts file in res/d.ts.
Use @babel/generator to convert the merged AST syntax tree into a d.ts file.

<br>

## Manually maintained files
| File Name | Description |
| :-----:| :----: |
| `res/config/primitive_type_mapping.json` | Used to configure some types/methods/properties that need to be ignored and types that need to be mapped. |
| `res/config/d.ts/additional_class.d.ts` | Used to add some unexposed interfaces that need to be fixed in the future. |
| `res/config/d.ts/builtin_class_method.d.ts` | Used to describe some built-in classes/modules/functions of JS Binding, such as AmazingManager, etc. |
| `res/config/d.ts/js_rtti_class.d.ts` | The data structure used to describe JSRTTI. |
| `res/config/d.ts/primitive_class.d.ts` | Used to describe some classes/modules/functions Gaia, such as AABB, Guid, Vector, etc. |

<br>

## Getting Started

### Setup

Initializes the enviornment

```bash
npm install
```

### `build`

Builds the ts. Will build any changes made to the ts. 

```bash
npm run build
```

### `gen_editor`

Generate editor version. Includes js_rtti_class.d.ts

```bash
npm run gen_editor
```

### `gen_runtime`

Generate the runtime version. Excludes js_rtti_class.d.ts

```bash
npm run gen_runtime
```

### `gen_html`

Generate HTML 

```bash
npm run gen_html
```

### `gen_readme`

Generate README

```bash
npm run gen_readme
```

<br>

## Publish

First, you need to log in to bnpm. The website of bnpm is [https://bnpm.bytedance.net/]. Make sure you are logged in on the webpage.
You can log in via SSO from the command line by running the following command

### Login bnpm
```
npm run login_bnpm
```

### `publish`
```
npm run publish
```
<br>
<br>

[Amazing JS API](https://amazingjs.web.bytedance.net)
